import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"solargraph","publisher":"castwide","displayName":"Ruby Solargraph","description":"A Ruby language server featuring code completion, intellisense, and inline documentation","icon":"solargraph.png","version":"0.24.1","categories":["Programming Languages","Linters","Formatters"],"keywords":["Ruby","autocomplete","intellisense","YARD","language server"],"repository":{"type":"git","url":"https://github.com/castwide/vscode-solargraph"},"license":"MIT","engines":{"vscode":"^1.64.0"},"extensionKind":["workspace"],"files":["views"],"contributes":{"configuration":{"title":"Solargraph settings for Ruby","properties":{"solargraph.transport":{"type":"string","default":"socket","enum":["socket","stdio","external"],"description":"The type of transport to use."},"solargraph.externalServer":{"type":"object","description":"The host and port to use for external transports. (Ignored for stdio and socket transports.)","properties":{"host":{"type":"string","default":"localhost"},"port":{"type":"integer","default":7658}},"default":{"host":"localhost","port":7658}},"solargraph.commandPath":{"type":"string","default":"solargraph","description":"Path to the solargraph command.  Set this to an absolute path to select from multiple installed Ruby versions.","scope":"resource"},"solargraph.useBundler":{"type":"boolean","description":"Use `bundle exec` to run solargraph. (If this is true, the solargraph.commandPath setting is ignored.)","default":false},"solargraph.bundlerPath":{"type":"string","description":"Path to the bundle executable, defaults to 'bundle'. Needs to be an absolute path for the 'bundle' exec/shim","default":"bundle","scope":"resource"},"solargraph.checkGemVersion":{"type":"boolean","description":"Automatically check if a new version of the Solargraph gem is available.","default":true,"enum":[true,false]},"solargraph.completion":{"type":["boolean"],"description":"Enable completion","default":true,"enum":[true,false]},"solargraph.hover":{"type":["boolean"],"description":"Enable hover","default":true,"enum":[true,false]},"solargraph.diagnostics":{"type":["boolean"],"description":"Enable diagnostics","default":false,"enum":[true,false]},"solargraph.autoformat":{"type":["boolean"],"description":"Enable automatic formatting while typing (WARNING: experimental)","default":false,"enum":[true,false]},"solargraph.formatting":{"type":["boolean"],"description":"Enable document formatting","enum":[true,false],"default":false},"solargraph.symbols":{"type":["boolean"],"description":"Enable symbols","enum":[true,false],"default":true},"solargraph.definitions":{"type":["boolean"],"description":"Enable definitions (go to, etc.)","enum":[true,false],"default":true},"solargraph.rename":{"type":["boolean"],"description":"Enable symbol renaming","enum":[true,false],"default":true},"solargraph.references":{"type":["boolean"],"description":"Enable finding references","enum":[true,false],"default":true},"solargraph.folding":{"type":"boolean","description":"Enable folding ranges","default":true},"solargraph.logLevel":{"type":"string","description":"Level of debug info to log. `warn` is least and `debug` is most.","enum":["warn","info","debug"],"default":"warn"}}}}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/castwide.solargraph-0.24.1.vsix/README.md', import.meta.url).href, 'text/markdown');

registerFileUrl('CHANGELOG.md', new URL('../assets/castwide.solargraph-0.24.1.vsix/CHANGELOG.md', import.meta.url).href, 'text/markdown');

registerFileUrl('package.json', new URL('../assets/castwide.solargraph-0.24.1.vsix/package.json', import.meta.url).href, 'application/json');

registerFileUrl('solargraph.png', new URL('../assets/castwide.solargraph-0.24.1.vsix/solargraph.png', import.meta.url).href, 'image/png');

export { whenReady };
