import { registerExtension } from 'vscode/extensions';

const manifest = {"private":true,"name":"vscode-angular","version":"1.0.22","repository":{"type":"git","url":"https://github.com/johnsoncodehk/volar.git","directory":"angular-language-tools/vscode-angular"},"displayName":"Angular Language Features (Volar)","description":"Angular Language Features (Volar)","author":"johnsoncodehk","publisher":"johnsoncodehk","engines":{"vscode":"^1.67.0"},"contributes":{"languages":[{"id":"angular-directives"},{"id":"angular-interpolations"},{"id":"html","configuration":"./languages/angular-template-language-configuration.json"}],"grammars":[{"language":"angular-directives","scopeName":"text.html.angular.directives","path":"./syntaxes/angular-directives.json","injectTo":["text.html.derivative"],"embeddedLanguages":{"source.ts":"typescript"}},{"language":"angular-interpolations","scopeName":"angular.interpolations","path":"./syntaxes/angular-interpolations.json","injectTo":["text.html.derivative"]}],"configuration":{"type":"object","title":"Volar-Angular","properties":{"volar.takeOverMode.extension":{"type":"string","default":"johnsoncodehk.vscode-angular","description":"The extension that take over language support for *.ts."},"volar-angular-language-server.trace.server":{"scope":"window","type":"string","enum":["off","messages","verbose"],"default":"off","description":"Traces the communication between VS Code and the language server."}}}}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md"});


registerFileUrl('README.md', new URL('../assets/johnsoncodehk.vscode-angular-1.0.22.vsix/README.md', import.meta.url).href, 'text/markdown');

registerFileUrl('syntaxes/angular-directives.json', new URL('../assets/johnsoncodehk.vscode-angular-1.0.22.vsix/angular-directives.json', import.meta.url).href, 'application/json');

registerFileUrl('syntaxes/angular-interpolations.json', new URL('../assets/johnsoncodehk.vscode-angular-1.0.22.vsix/angular-interpolations.json', import.meta.url).href, 'application/json');

registerFileUrl('languages/angular-template-language-configuration.json', new URL('../assets/johnsoncodehk.vscode-angular-1.0.22.vsix/angular-template-language-configuration.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/johnsoncodehk.vscode-angular-1.0.22.vsix/package.json', import.meta.url).href, 'application/json');

export { whenReady };
