import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"python","displayName":"Python","description":"IntelliSense (Pylance), Linting, Debugging (Python Debugger), code formatting, refactoring, unit tests, and more.","version":"2023.25.10221012","featureFlags":{"usingNewInterpreterStorage":true},"capabilities":{"untrustedWorkspaces":{"supported":"limited","description":"Only Partial IntelliSense with Pylance is supported. Cannot execute Python with untrusted files."},"virtualWorkspaces":{"supported":"limited","description":"Only Partial IntelliSense supported."}},"publisher":"ms-python","enabledApiProposals":["contribEditorContentMenu","quickPickSortByLabel","testObserver","quickPickItemTooltip","saveEditor","terminalDataWriteEvent","terminalExecuteCommandEvent"],"author":{"name":"Microsoft Corporation"},"license":"MIT","homepage":"https://github.com/Microsoft/vscode-python","repository":{"type":"git","url":"https://github.com/Microsoft/vscode-python"},"bugs":{"url":"https://github.com/Microsoft/vscode-python/issues"},"qna":"https://github.com/microsoft/vscode-python/discussions/categories/q-a","icon":"icon.png","galleryBanner":{"color":"#1e415e","theme":"dark"},"engines":{"vscode":"^1.82.0"},"enableTelemetry":true,"keywords":["python","django","unittest","multi-root ready"],"categories":["Programming Languages","Debuggers","Linters","Formatters","Other","Data Science","Machine Learning"],"contributes":{"configuration":{"properties":{"python.activeStateToolPath":{"default":"state","description":"%python.activeStateToolPath.description%","scope":"machine-overridable","type":"string"},"python.autoComplete.extraPaths":{"default":[],"description":"%python.autoComplete.extraPaths.description%","scope":"resource","type":"array","uniqueItems":true},"python.createEnvironment.contentButton":{"default":"show","markdownDescription":"%python.createEnvironment.contentButton.description%","scope":"machine-overridable","type":"string","enum":["show","hide"]},"python.createEnvironment.trigger":{"default":"off","markdownDescription":"%python.createEnvironment.trigger.description%","scope":"machine-overridable","type":"string","enum":["off","prompt"],"tags":["experimental"]},"python.condaPath":{"default":"","description":"%python.condaPath.description%","scope":"machine","type":"string"},"python.defaultInterpreterPath":{"default":"python","markdownDescription":"%python.defaultInterpreterPath.description%","scope":"machine-overridable","type":"string"},"python.diagnostics.sourceMapsEnabled":{"default":false,"description":"%python.diagnostics.sourceMapsEnabled.description%","scope":"application","type":"boolean"},"python.envFile":{"default":"${workspaceFolder}/.env","description":"%python.envFile.description%","scope":"resource","type":"string"},"python.experiments.enabled":{"default":true,"description":"%python.experiments.enabled.description%","scope":"machine","type":"boolean"},"python.experiments.optInto":{"default":[],"markdownDescription":"%python.experiments.optInto.description%","items":{"enum":["All","pythonSurveyNotification","pythonPromptNewToolsExt","pythonTerminalEnvVarActivation","pythonDiscoveryUsingWorkers","pythonTestAdapter","pythonREPLSmartSend","pythonRecommendTensorboardExt"],"enumDescriptions":["%python.experiments.All.description%","%python.experiments.pythonSurveyNotification.description%","%python.experiments.pythonPromptNewToolsExt.description%","%python.experiments.pythonTerminalEnvVarActivation.description%","%python.experiments.pythonDiscoveryUsingWorkers.description%","%python.experiments.pythonTestAdapter.description%","%python.experiments.pythonREPLSmartSend.description%","%python.experiments.pythonRecommendTensorboardExt.description%"]},"scope":"machine","type":"array","uniqueItems":true},"python.experiments.optOutFrom":{"default":[],"markdownDescription":"%python.experiments.optOutFrom.description%","items":{"enum":["All","pythonSurveyNotification","pythonPromptNewToolsExt","pythonTerminalEnvVarActivation","pythonDiscoveryUsingWorkers","pythonTestAdapter","pythonREPLSmartSend"],"enumDescriptions":["%python.experiments.All.description%","%python.experiments.pythonSurveyNotification.description%","%python.experiments.pythonPromptNewToolsExt.description%","%python.experiments.pythonTerminalEnvVarActivation.description%","%python.experiments.pythonDiscoveryUsingWorkers.description%","%python.experiments.pythonTestAdapter.description%","%python.experiments.pythonREPLSmartSend.description%"]},"scope":"machine","type":"array","uniqueItems":true},"python.globalModuleInstallation":{"default":false,"description":"%python.globalModuleInstallation.description%","scope":"resource","type":"boolean"},"python.languageServer":{"default":"Default","description":"%python.languageServer.description%","enum":["Default","Jedi","Pylance","None"],"enumDescriptions":["%python.languageServer.defaultDescription%","%python.languageServer.jediDescription%","%python.languageServer.pylanceDescription%","%python.languageServer.noneDescription%"],"scope":"window","type":"string"},"python.interpreter.infoVisibility":{"default":"onPythonRelated","description":"%python.interpreter.infoVisibility.description%","enum":["never","onPythonRelated","always"],"enumDescriptions":["%python.interpreter.infoVisibility.never.description%","%python.interpreter.infoVisibility.onPythonRelated.description%","%python.interpreter.infoVisibility.always.description%"],"scope":"machine","type":"string"},"python.logging.level":{"default":"error","deprecationMessage":"%python.logging.level.deprecation%","description":"%python.logging.level.description%","enum":["debug","error","info","off","warn"],"scope":"machine","type":"string"},"python.missingPackage.severity":{"default":"Hint","description":"%python.missingPackage.severity.description%","enum":["Error","Hint","Information","Warning"],"scope":"resource","type":"string","tags":["experimental"]},"python.pipenvPath":{"default":"pipenv","description":"%python.pipenvPath.description%","scope":"machine-overridable","type":"string"},"python.poetryPath":{"default":"poetry","description":"%python.poetryPath.description%","scope":"machine-overridable","type":"string"},"python.tensorBoard.logDirectory":{"default":"","description":"%python.tensorBoard.logDirectory.description%","scope":"resource","type":"string","markdownDeprecationMessage":"%python.tensorBoard.logDirectory.markdownDeprecationMessage%","deprecationMessage":"%python.tensorBoard.logDirectory.deprecationMessage%"},"python.terminal.activateEnvInCurrentTerminal":{"default":false,"description":"%python.terminal.activateEnvInCurrentTerminal.description%","scope":"resource","type":"boolean"},"python.terminal.activateEnvironment":{"default":true,"description":"%python.terminal.activateEnvironment.description%","scope":"resource","type":"boolean"},"python.terminal.executeInFileDir":{"default":false,"description":"%python.terminal.executeInFileDir.description%","scope":"resource","type":"boolean"},"python.terminal.focusAfterLaunch":{"default":false,"description":"%python.terminal.focusAfterLaunch.description%","scope":"resource","type":"boolean"},"python.terminal.launchArgs":{"default":[],"description":"%python.terminal.launchArgs.description%","scope":"resource","type":"array"},"python.REPL.enableREPLSmartSend":{"default":true,"description":"%python.EnableREPLSmartSend.description%","scope":"resource","type":"boolean"},"python.testing.autoTestDiscoverOnSaveEnabled":{"default":true,"description":"%python.testing.autoTestDiscoverOnSaveEnabled.description%","scope":"resource","type":"boolean"},"python.testing.cwd":{"default":null,"description":"%python.testing.cwd.description%","scope":"resource","type":"string"},"python.testing.debugPort":{"default":3000,"description":"%python.testing.debugPort.description%","scope":"resource","type":"number"},"python.testing.promptToConfigure":{"default":true,"description":"%python.testing.promptToConfigure.description%","scope":"resource","type":"boolean"},"python.testing.pytestArgs":{"default":[],"description":"%python.testing.pytestArgs.description%","items":{"type":"string"},"scope":"resource","type":"array"},"python.testing.pytestEnabled":{"default":false,"description":"%python.testing.pytestEnabled.description%","scope":"resource","type":"boolean"},"python.testing.pytestPath":{"default":"pytest","description":"%python.testing.pytestPath.description%","scope":"machine-overridable","type":"string"},"python.testing.unittestArgs":{"default":["-v","-s",".","-p","*test*.py"],"description":"%python.testing.unittestArgs.description%","items":{"type":"string"},"scope":"resource","type":"array"},"python.testing.unittestEnabled":{"default":false,"description":"%python.testing.unittestEnabled.description%","scope":"resource","type":"boolean"},"python.venvFolders":{"default":[],"description":"%python.venvFolders.description%","items":{"type":"string"},"scope":"machine","type":"array","uniqueItems":true},"python.venvPath":{"default":"","description":"%python.venvPath.description%","scope":"machine","type":"string"}},"title":"Python","type":"object"},"grammars":[{"language":"pip-requirements","path":"./syntaxes/pip-requirements.tmLanguage.json","scopeName":"source.pip-requirements"}],"jsonValidation":[{"fileMatch":".condarc","url":"./schemas/condarc.json"},{"fileMatch":"environment.yml","url":"./schemas/conda-environment.json"},{"fileMatch":"meta.yaml","url":"./schemas/conda-meta.json"}],"languages":[{"aliases":["Jinja"],"extensions":[".j2",".jinja2"],"id":"jinja"},{"aliases":["pip requirements","requirements.txt"],"configuration":"./languages/pip-requirements.json","filenamePatterns":["**/*requirements*.{txt, in}","**/*constraints*.txt","**/requirements/*.{txt,in}","**/constraints/*.txt"],"filenames":["constraints.txt","requirements.in","requirements.txt"],"id":"pip-requirements"},{"filenames":[".condarc"],"id":"yaml"},{"filenames":[".flake8",".pep8",".pylintrc",".pypirc"],"id":"ini"},{"filenames":["Pipfile","poetry.lock"],"id":"toml"},{"filenames":["Pipfile.lock"],"id":"json"}],"submenus":[{"id":"python.run","label":"%python.editor.context.submenu.runPython%","icon":"$(play)"},{"id":"python.runFileInteractive","label":"%python.editor.context.submenu.runPythonInteractive%"}],"yamlValidation":[{"fileMatch":".condarc","url":"./schemas/condarc.json"},{"fileMatch":"environment.yml","url":"./schemas/conda-environment.json"},{"fileMatch":"meta.yaml","url":"./schemas/conda-meta.json"}]},"extensionPack":["ms-python.vscode-pylance","ms-python.debugpy"]};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/ms-python.python-2023.25.10221012.vsix/README.md', import.meta.url).href, 'text/markdown');

registerFileUrl('CHANGELOG.md', new URL('../assets/ms-python.python-2023.25.10221012.vsix/CHANGELOG.md', import.meta.url).href, 'text/markdown');

registerFileUrl('syntaxes/pip-requirements.tmLanguage.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/pip-requirements.tmLanguage.json', import.meta.url).href, 'application/json');

registerFileUrl('languages/pip-requirements.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/pip-requirements.json', import.meta.url).href, 'application/json');

registerFileUrl('schemas/condarc.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/condarc.json', import.meta.url).href, 'application/json');

registerFileUrl('schemas/conda-environment.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/conda-environment.json', import.meta.url).href, 'application/json');

registerFileUrl('schemas/conda-meta.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/conda-meta.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.cs.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.cs.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.de.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.de.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.es.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.es.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.fr.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.fr.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.it.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.it.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ja.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.ja.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ko.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.ko.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pl.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.pl.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pt-br.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.pt-br.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.qps-ploc.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.qps-ploc.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ru.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.ru.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.tr.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.tr.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-cn.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.zh-cn.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-tw.json', new URL('../assets/ms-python.python-2023.25.10221012.vsix/package.nls.zh-tw.json', import.meta.url).href, 'application/json');

registerFileUrl('icon.png', new URL('../assets/ms-python.python-2023.25.10221012.vsix/icon.png', import.meta.url).href, 'image/png');

export { whenReady };
