import * as monaco from 'monaco-editor';
export { monaco };
export { createEditor, createModelReference, registerEditorOpenHandler } from './monaco.js';
export { getConfiguration, onConfigurationChanged, registerConfigurations, registerDefaultConfigurations } from './configuration/index.js';
export { getMonacoLanguage, loadLanguage } from './languages/index.js';
export { updateEditorKeybindingsMode, updateKeybindings } from './keybindings/index.js';
export { generateAndInitializeWorkspace, initialize, initializePromise, isInitialized, setUseGlobalPicker } from './services.js';
import './style.js';
export { addPlaceholder, collapseCodeSections, hideCodeWithoutDecoration, lockCodeWithoutDecoration, mapClipboard, preventAlwaysConsumeTouchEvent, registerTextDecorationProvider, runOnAllEditors } from './tools.js';
export { getUserConfiguration, onUserConfigurationChange, updateUserConfiguration } from '@codingame/monaco-vscode-configuration-service-override';
