import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"cpptools","displayName":"C/C++","description":"C/C++ IntelliSense, debugging, and code browsing.","version":"1.19.2","publisher":"ms-vscode","icon":"LanguageCCPP_color_128x.png","readme":"README.md","author":{"name":"Microsoft Corporation"},"license":"SEE LICENSE IN LICENSE.txt","engines":{"vscode":"^1.67.0"},"bugs":{"url":"https://github.com/Microsoft/vscode-cpptools/issues","email":"c_cpp_support@microsoft.com"},"repository":{"type":"git","url":"https://github.com/Microsoft/vscode-cpptools.git"},"homepage":"https://github.com/Microsoft/vscode-cpptools","qna":"https://github.com/Microsoft/vscode-cpptools/issues","keywords":["C","C++","IntelliSense","Microsoft","multi-root ready"],"categories":["Programming Languages","Debuggers","Formatters","Linters","Snippets"],"enabledApiProposals":["terminalDataWriteEvent"],"capabilities":{"untrustedWorkspaces":{"supported":false,"description":"%c_cpp.capabilities.untrustedWorkspaces.description%"},"virtualWorkspaces":false},"contributes":{"problemMatchers":[{"name":"gcc","source":"gcc","owner":"cpptools","fileLocation":["autoDetect","${cwd}"],"pattern":{"regexp":"^(.*?):(\\d+):(\\d*):?\\s+(?:fatal\\s+)?(warning|error):\\s+(.*)$","file":1,"line":2,"column":3,"severity":4,"message":5}},{"name":"iar","source":"iar","owner":"cpptools","fileLocation":"absolute","pattern":{"regexp":"^\"(.*?)\",(\\d+)\\s+(?:[Ff]atal\\s+)?([Ww]arning|[Ee]rror)\\[(\\w+\\d+)\\]:\\s+(.*)$","file":1,"line":2,"severity":3,"code":4,"message":5}},{"name":"armcc5","source":"armcc5","owner":"cpptools","fileLocation":["autoDetect","${cwd}"],"pattern":{"regexp":"^\"(.*)?\",\\s+line\\s+(\\d+):\\s+([Ee]rror|[Ww]arning):\\s+#(.*?):\\s+(.*)$","file":1,"line":2,"severity":3,"code":4,"message":5}}],"configuration":[{"title":"%c_cpp.subheaders.intelliSense.title%","properties":{"C_Cpp.inlayHints.autoDeclarationTypes.enabled":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.inlayHints.autoDeclarationTypes.enabled.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.autoDeclarationTypes.showOnLeft":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.inlayHints.autoDeclarationTypes.showOnLeft.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.parameterNames.enabled":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.inlayHints.parameterNames.enabled.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.parameterNames.suppressWhenArgumentContainsName":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.inlayHints.parameterNames.suppressWhenArgumentContainsName.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.parameterNames.hideLeadingUnderscores":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.inlayHints.parameterNames.hideLeadingUnderscores.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.referenceOperator.enabled":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.inlayHints.referenceOperator.enabled.markdownDescription%","scope":"resource"},"C_Cpp.inlayHints.referenceOperator.showSpace":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.inlayHints.referenceOperator.showSpace.markdownDescription%","scope":"resource"},"C_Cpp.intelliSenseUpdateDelay":{"type":"number","default":2000,"description":"%c_cpp.configuration.intelliSenseUpdateDelay.description%","scope":"application","minimum":500,"maximum":3000},"C_Cpp.codeFolding":{"type":"string","enum":["enabled","disabled"],"default":"enabled","description":"%c_cpp.configuration.codeFolding.description%","scope":"window"},"C_Cpp.autocompleteAddParentheses":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.autocompleteAddParentheses.markdownDescription%","scope":"resource"},"C_Cpp.suggestSnippets":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.suggestSnippets.markdownDescription%","scope":"resource"},"C_Cpp.enhancedColorization":{"type":"string","enum":["enabled","disabled"],"default":"enabled","markdownDescription":"%c_cpp.configuration.enhancedColorization.markdownDescription%","scope":"window"},"C_Cpp.legacyCompilerArgsBehavior":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.legacyCompilerArgsBehavior.markdownDescription%","scope":"resource"},"C_Cpp.autocomplete":{"type":"string","enum":["default","disabled"],"default":"default","markdownDescription":"%c_cpp.configuration.autocomplete.markdownDescription%","enumDescriptions":["%c_cpp.configuration.autocomplete.default.description%","%c_cpp.configuration.autocomplete.disabled.description%"],"scope":"resource"},"C_Cpp.hover":{"type":"string","enum":["default","disabled"],"default":"default","description":"%c_cpp.configuration.hover.description%","scope":"resource"},"C_Cpp.errorSquiggles":{"type":"string","enum":["enabled","disabled","enabledIfIncludesResolve"],"default":"enabledIfIncludesResolve","description":"%c_cpp.configuration.errorSquiggles.description%","scope":"resource"},"C_Cpp.dimInactiveRegions":{"type":"boolean","default":true,"description":"%c_cpp.configuration.dimInactiveRegions.description%","scope":"resource"},"C_Cpp.inactiveRegionOpacity":{"type:":"number","default":0.55,"markdownDescription":"%c_cpp.configuration.inactiveRegionOpacity.markdownDescription%","scope":"resource","minimum":0.1,"maximum":1},"C_Cpp.inactiveRegionForegroundColor":{"type":"string","description":"%c_cpp.configuration.inactiveRegionForegroundColor.description%","scope":"resource"},"C_Cpp.inactiveRegionBackgroundColor":{"type":"string","description":"%c_cpp.configuration.inactiveRegionBackgroundColor.description%","scope":"resource"},"C_Cpp.refactoring.includeHeader":{"type":"string","enum":["always","ifNeeded","never"],"default":"always","markdownDescription":"%c_cpp.configuration.refactoring.includeHeader.markdownDescription%","enumDescriptions":["%c_cpp.configuration.refactoring.includeHeader.always.description%","%c_cpp.configuration.refactoring.includeHeader.ifNeeded.description%","%c_cpp.configuration.refactoring.includeHeader.never.description%"],"scope":"resource"},"C_Cpp.renameRequiresIdentifier":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.renameRequiresIdentifier.markdownDescription%","scope":"application"},"C_Cpp.workspaceSymbols":{"type":"string","enum":["All","Just My Code"],"default":"Just My Code","description":"%c_cpp.configuration.workspaceSymbols.description%","scope":"window"},"C_Cpp.default.includePath":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.includePath.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.defines":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.defines.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.macFrameworkPath":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.macFrameworkPath.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.windowsSdkVersion":{"type":"string","markdownDescription":"%c_cpp.configuration.default.windowsSdkVersion.markdownDescription%","pattern":"^((\\d{2}\\.\\d{1}\\.\\d{5}\\.\\d{1}$|^8\\.1)|())$","scope":"machine-overridable"},"C_Cpp.default.compileCommands":{"type":"string","markdownDescription":"%c_cpp.configuration.default.compileCommands.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.forcedInclude":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.forcedInclude.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.intelliSenseMode":{"type":"string","enum":["","macos-clang-x86","macos-clang-x64","macos-clang-arm","macos-clang-arm64","macos-gcc-x86","macos-gcc-x64","macos-gcc-arm","macos-gcc-arm64","linux-clang-x86","linux-clang-x64","linux-clang-arm","linux-clang-arm64","linux-gcc-x86","linux-gcc-x64","linux-gcc-arm","linux-gcc-arm64","windows-clang-x86","windows-clang-x64","windows-clang-arm","windows-clang-arm64","windows-gcc-x86","windows-gcc-x64","windows-gcc-arm","windows-gcc-arm64","windows-msvc-x86","windows-msvc-x64","windows-msvc-arm","windows-msvc-arm64","clang-x86","clang-x64","clang-arm","clang-arm64","gcc-x86","gcc-x64","gcc-arm","gcc-arm64","msvc-x86","msvc-x64","msvc-arm","msvc-arm64"],"markdownDescription":"%c_cpp.configuration.default.intelliSenseMode.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.compilerPath":{"type":["string","null"],"default":null,"markdownDescription":"%c_cpp.configuration.default.compilerPath.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.compilerArgs":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.compilerArgs.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.cStandard":{"type":"string","enum":["","c89","c99","c11","c17","c23","gnu89","gnu99","gnu11","gnu17","gnu23"],"markdownDescription":"%c_cpp.configuration.default.cStandard.markdownDescription%","scope":"resource"},"C_Cpp.default.cppStandard":{"type":"string","enum":["","c++98","c++03","c++11","c++14","c++17","c++20","c++23","gnu++98","gnu++03","gnu++11","gnu++14","gnu++17","gnu++20","gnu++23"],"markdownDescription":"%c_cpp.configuration.default.cppStandard.markdownDescription%","scope":"resource"},"C_Cpp.default.configurationProvider":{"type":"string","markdownDescription":"%c_cpp.configuration.default.configurationProvider.markdownDescription%","scope":"resource"},"C_Cpp.default.mergeConfigurations":{"type":"boolean","markdownDescription":"%c_cpp.configuration.default.mergeConfigurations.markdownDescription%","scope":"resource"},"C_Cpp.default.browse.path":{"type":"array","items":{"type":"string"},"default":null,"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.browse.path.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.browse.databaseFilename":{"type":"string","markdownDescription":"%c_cpp.configuration.default.browse.databaseFilename.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.browse.limitSymbolsToIncludedHeaders":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.default.browse.limitSymbolsToIncludedHeaders.markdownDescription%","scope":"resource"},"C_Cpp.default.systemIncludePath":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.default.systemIncludePath.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.customConfigurationVariables":{"type":["object","null"],"default":null,"patternProperties":{"(^.+$)":{"type":"string"}},"markdownDescription":"%c_cpp.configuration.default.customConfigurationVariables.markdownDescription%","scope":"machine-overridable"},"C_Cpp.default.enableConfigurationSquiggles":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.default.enableConfigurationSquiggles.markdownDescription%","scope":"resource"},"C_Cpp.default.dotConfig":{"type":"string","markdownDescription":"%c_cpp.configuration.default.dotConfig.markdownDescription%","scope":"resource"},"C_Cpp.configurationWarnings":{"type":"string","enum":["enabled","disabled"],"default":"enabled","description":"%c_cpp.configuration.configurationWarnings.description%","scope":"resource"},"C_Cpp.workspaceParsingPriority":{"type":"string","enum":["highest","high","medium","low"],"default":"highest","markdownDescription":"%c_cpp.configuration.workspaceParsingPriority.markdownDescription%","scope":"window"},"C_Cpp.intelliSenseEngine":{"type":"string","enum":["default","Tag Parser","disabled"],"default":"default","description":"%c_cpp.configuration.intelliSenseEngine.description%","enumDescriptions":["%c_cpp.configuration.intelliSenseEngine.default.description%","%c_cpp.configuration.intelliSenseEngine.tagParser.description%","%c_cpp.configuration.intelliSenseEngine.disabled.description%"],"scope":"resource"},"C_Cpp.intelliSenseEngineFallback":{"type":"string","enum":["enabled","disabled"],"default":"disabled","markdownDescription":"%c_cpp.configuration.intelliSenseEngineFallback.markdownDescription%","scope":"resource"},"C_Cpp.exclusionPolicy":{"type":"string","enum":["checkFolders","checkFilesAndFolders"],"default":"checkFolders","markdownDescription":"%c_cpp.configuration.exclusionPolicy.markdownDescription%","enumDescriptions":["%c_cpp.configuration.exclusionPolicy.checkFolders.description%","%c_cpp.configuration.exclusionPolicy.checkFilesAndFolders.description%"],"scope":"resource"},"C_Cpp.files.exclude":{"type":"object","markdownDescription":"%c_cpp.configuration.filesExclude.markdownDescription%","default":{"**/.vscode":true,"**/.vs":true},"additionalProperties":{"anyOf":[{"type":"boolean","markdownDescription":"%c_cpp.configuration.filesExcludeBoolean.markdownDescription%"},{"type":"object","properties":{"when":{"type":"string","pattern":"\\w*\\$\\(basename\\)\\w*","default":"$(basename).ext","markdownDescription":"%c_cpp.configuration.filesExcludeWhen.markdownDescription%"}}}]},"scope":"resource"}}},{"title":"%c_cpp.subheaders.formatting.title%","properties":{"C_Cpp.vcFormat.indent.braces":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.braces.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.multiLineRelativeTo":{"type":"string","enum":["outermostParenthesis","innermostParenthesis","statementBegin"],"enumDescriptions":["%c_cpp.configuration.vcFormat.indent.multiLineRelativeTo.outermostParenthesis.description%","%c_cpp.configuration.vcFormat.indent.multiLineRelativeTo.innermostParenthesis.description%","%c_cpp.configuration.vcFormat.indent.multiLineRelativeTo.statementBegin.description%"],"default":"innermostParenthesis","description":"%c_cpp.configuration.vcFormat.indent.multiLineRelativeTo.description%","scope":"resource"},"C_Cpp.vcFormat.indent.withinParentheses":{"type":"string","enum":["alignToParenthesis","indent"],"markdownEnumDescriptions":["%c_cpp.configuration.vcFormat.indent.withinParentheses.alignToParenthesis.markdownDescription%","%c_cpp.configuration.vcFormat.indent.withinParentheses.indent.markdownDescription%"],"default":"indent","markdownDescription":"%c_cpp.configuration.vcFormat.indent.withinParentheses.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.preserveWithinParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.indent.preserveWithinParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.indent.caseLabels":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.caseLabels.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.caseContents":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.caseContents.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.caseContentsWhenBlock":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.caseContentsWhenBlock.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.lambdaBracesWhenParameter":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.lambdaBracesWhenParameter.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.gotoLabels":{"type":"string","enum":["oneLeft","leftmostColumn","none"],"markdownEnumDescriptions":["%c_cpp.configuration.vcFormat.indent.gotoLabels.oneLeft.markdownDescription%","%c_cpp.configuration.vcFormat.indent.gotoLabels.leftmostColumn.markdownDescription%","%c_cpp.configuration.vcFormat.indent.gotoLabels.none.markdownDescription%"],"default":"oneLeft","description":"%c_cpp.configuration.vcFormat.indent.gotoLabels.description%","scope":"resource"},"C_Cpp.vcFormat.indent.preprocessor":{"type":"string","enum":["oneLeft","leftmostColumn","none"],"markdownEnumDescriptions":["%c_cpp.configuration.vcFormat.indent.preprocessor.oneLeft.markdownDescription%","%c_cpp.configuration.vcFormat.indent.preprocessor.leftmostColumn.markdownDescription%","%c_cpp.configuration.vcFormat.indent.preprocessor.none.markdownDescription%"],"default":"leftmostColumn","description":"%c_cpp.configuration.vcFormat.indent.preprocessor.description%","scope":"resource"},"C_Cpp.vcFormat.indent.accessSpecifiers":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.accessSpecifiers.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.namespaceContents":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcFormat.indent.namespaceContents.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.indent.preserveComments":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.indent.preserveComments.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeOpenBrace.namespace":{"type":"string","enum":["newLine","sameLine","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.newLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.sameLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.ignore.description%"],"default":"ignore","description":"%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.namespace.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeOpenBrace.type":{"type":"string","enum":["newLine","sameLine","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.newLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.sameLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.ignore.description%"],"default":"ignore","description":"%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.type.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeOpenBrace.function":{"type":"string","enum":["newLine","sameLine","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.newLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.sameLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.ignore.description%"],"default":"ignore","description":"%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.function.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeOpenBrace.block":{"type":"string","enum":["newLine","sameLine","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.newLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.sameLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.ignore.description%"],"default":"ignore","description":"%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.block.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeOpenBrace.lambda":{"enum":["newLine","sameLine","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.newLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.sameLine.description%","%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.ignore.description%"],"default":"ignore","description":"%c_cpp.configuration.vcFormat.newLine.beforeOpenBrace.lambda.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.scopeBracesOnSeparateLines":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.newLine.scopeBracesOnSeparateLines.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.closeBraceSameLine.emptyType":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.newLine.closeBraceSameLine.emptyType.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.closeBraceSameLine.emptyFunction":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.newLine.closeBraceSameLine.emptyFunction.description%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeCatch":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcFormat.newLine.beforeCatch.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeElse":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcFormat.newLine.beforeElse.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.newLine.beforeWhileInDoWhile":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.vcFormat.newLine.beforeWhileInDoWhile.markdownDescription%","scope":"resource"},"C_Cpp.vcFormat.space.beforeFunctionOpenParenthesis":{"type":"string","enum":["insert","remove","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.space.beforeFunctionOpenParenthesis.insert.description%","%c_cpp.configuration.vcFormat.space.beforeFunctionOpenParenthesis.remove.description%","%c_cpp.configuration.vcFormat.space.beforeFunctionOpenParenthesis.ignore.description%"],"default":"remove","description":"%c_cpp.configuration.vcFormat.space.beforeFunctionOpenParenthesis.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinParameterListParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinParameterListParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.space.betweenEmptyParameterListParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.betweenEmptyParameterListParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.space.afterKeywordsInControlFlowStatements":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.afterKeywordsInControlFlowStatements.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinControlFlowStatementParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinControlFlowStatementParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeLambdaOpenParenthesis":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.beforeLambdaOpenParenthesis.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinCastParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinCastParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.space.afterCastCloseParenthesis":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.afterCastCloseParenthesis.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinExpressionParentheses":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinExpressionParentheses.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeBlockOpenBrace":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.beforeBlockOpenBrace.description%","scope":"resource"},"C_Cpp.vcFormat.space.betweenEmptyBraces":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.betweenEmptyBraces.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeInitializerListOpenBrace":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.beforeInitializerListOpenBrace.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinInitializerListBraces":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.withinInitializerListBraces.description%","scope":"resource"},"C_Cpp.vcFormat.space.preserveInInitializerList":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.preserveInInitializerList.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeOpenSquareBracket":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.beforeOpenSquareBracket.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinSquareBrackets":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinSquareBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeEmptySquareBrackets":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.beforeEmptySquareBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.betweenEmptySquareBrackets":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.betweenEmptySquareBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.groupSquareBrackets":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.groupSquareBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.withinLambdaBrackets":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.withinLambdaBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.betweenEmptyLambdaBrackets":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.betweenEmptyLambdaBrackets.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeComma":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.beforeComma.description%","scope":"resource"},"C_Cpp.vcFormat.space.afterComma":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.afterComma.description%","scope":"resource"},"C_Cpp.vcFormat.space.removeAroundMemberOperators":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.removeAroundMemberOperators.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeInheritanceColon":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.beforeInheritanceColon.description%","scope":"resource"},"C_Cpp.vcFormat.space.beforeConstructorColon":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.beforeConstructorColon.description%","scope":"resource"},"C_Cpp.vcFormat.space.removeBeforeSemicolon":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.removeBeforeSemicolon.description%","scope":"resource"},"C_Cpp.vcFormat.space.insertAfterSemicolon":{"type":"boolean","default":false,"description":"%c_cpp.configuration.vcFormat.space.insertAfterSemicolon.description%","scope":"resource"},"C_Cpp.vcFormat.space.removeAroundUnaryOperator":{"type":"boolean","default":true,"description":"%c_cpp.configuration.vcFormat.space.removeAroundUnaryOperator.description%","scope":"resource"},"C_Cpp.vcFormat.space.aroundBinaryOperator":{"type":"string","enum":["insert","remove","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.space.aroundOperators.insert.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.remove.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.ignore.description%"],"default":"insert","description":"%c_cpp.configuration.vcFormat.space.aroundBinaryOperator.description%","scope":"resource"},"C_Cpp.vcFormat.space.aroundAssignmentOperator":{"type":"string","enum":["insert","remove","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.space.aroundOperators.insert.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.remove.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.ignore.description%"],"default":"insert","description":"%c_cpp.configuration.vcFormat.space.aroundAssignmentOperator.description%","scope":"resource"},"C_Cpp.vcFormat.space.pointerReferenceAlignment":{"type":"string","enum":["left","center","right","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.space.pointerReferenceAlignment.left.description%","%c_cpp.configuration.vcFormat.space.pointerReferenceAlignment.center.description%","%c_cpp.configuration.vcFormat.space.pointerReferenceAlignment.right.description%","%c_cpp.configuration.vcFormat.space.pointerReferenceAlignment.ignore.description%"],"default":"left","description":"%c_cpp.configuration.vcFormat.space.pointerReferenceAlignment.description%","scope":"resource"},"C_Cpp.vcFormat.space.aroundTernaryOperator":{"type":"string","enum":["insert","remove","ignore"],"enumDescriptions":["%c_cpp.configuration.vcFormat.space.aroundOperators.insert.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.remove.description%","%c_cpp.configuration.vcFormat.space.aroundOperators.ignore.description%"],"default":"insert","description":"%c_cpp.configuration.vcFormat.space.aroundTernaryOperator.description%","scope":"resource"},"C_Cpp.vcFormat.wrap.preserveBlocks":{"type":"string","enum":["oneLiners","allOneLineScopes","never"],"markdownEnumDescriptions":["%c_cpp.configuration.vcFormat.wrap.preserveBlocks.oneLiners.markdownDescription%","%c_cpp.configuration.vcFormat.wrap.preserveBlocks.allOneLineScopes.markdownDescription%","%c_cpp.configuration.vcFormat.wrap.preserveBlocks.never.markdownDescription%"],"default":"oneLiners","description":"%c_cpp.configuration.vcFormat.wrap.preserveBlocks.description%","scope":"resource"},"C_Cpp.clang_format_path":{"type":"string","markdownDescription":"%c_cpp.configuration.clang_format_path.markdownDescription%","scope":"machine-overridable"},"C_Cpp.clang_format_style":{"type":"string","default":"file","markdownDescription":"%c_cpp.configuration.clang_format_style.markdownDescription%","scope":"resource"},"C_Cpp.formatting":{"type":"string","enum":["clangFormat","vcFormat","default","disabled"],"markdownEnumDescriptions":["%c_cpp.configuration.formatting.clangFormat.markdownDescription%","%c_cpp.configuration.formatting.vcFormat.markdownDescription%","%c_cpp.configuration.formatting.Default.markdownDescription%","%c_cpp.configuration.formatting.Disabled.markdownDescription%"],"default":"default","description":"%c_cpp.configuration.formatting.description%","scope":"resource"},"C_Cpp.clang_format_fallbackStyle":{"type":"string","default":"Visual Studio","markdownDescription":"%c_cpp.configuration.clang_format_fallbackStyle.markdownDescription%","scope":"resource"},"C_Cpp.clang_format_sortIncludes":{"type":["boolean","null"],"enum":[true,false,null],"default":null,"markdownDescription":"%c_cpp.configuration.clang_format_sortIncludes.markdownDescription%","scope":"resource"}}},{"title":"%c_cpp.subheaders.codeDocumentation.title%","properties":{"C_Cpp.doxygen.generateOnType":{"type":"boolean","default":true,"description":"%c_cpp.configuration.doxygen.generateOnType.description%","scope":"resource"},"C_Cpp.doxygen.generatedStyle":{"type":"string","enum":["///","/**","/*!","//!"],"default":"///","description":"%c_cpp.configuration.doxygen.generatedStyle.description%","scope":"resource"},"C_Cpp.doxygen.sectionTags":{"type":"array","default":["attention","tparam","param","result","returns","retval","exception","deprecated","warning","note"],"items":{"type":"string","enum":["attention","author","authors","bug","copyright","date","deprecated","details","exception","invariant","note","param","pre","post","remark","remarks","result","returns","retval","since","tparam","test","todo","version","warning"]},"description":"%c_cpp.configuration.doxygen.sectionTags.description%","scope":"resource"},"C_Cpp.commentContinuationPatterns":{"type":"array","default":["/**"],"items":{"anyOf":[{"type":"string","markdownDescription":"%c_cpp.configuration.commentContinuationPatterns.items.anyof.string.markdownDescription%"},{"type":"object","properties":{"begin":{"type":"string","description":"%c_cpp.configuration.commentContinuationPatterns.items.anyof.object.begin.description%"},"continue":{"type":"string","description":"%c_cpp.configuration.commentContinuationPatterns.items.anyof.object.continue.description%"}}}]},"uniqueItems":true,"description":"%c_cpp.configuration.commentContinuationPatterns.description%","scope":"window"},"C_Cpp.markdownInComments":{"type":"string","enum":["subsetEnabled","enabled","disabled"],"enumDescriptions":["%c_cpp.configuration.markdownInComments.subsetEnabled.description%","%c_cpp.configuration.markdownInComments.enabled.description%","%c_cpp.configuration.markdownInComments.disabled.description%"],"default":"subsetEnabled","description":"%c_cpp.configuration.markdownInComments.description%","scope":"resource"},"C_Cpp.simplifyStructuredComments":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.simplifyStructuredComments.markdownDescription%","scope":"application"}}},{"title":"%c_cpp.subheaders.codeAnalysis.title%","properties":{"C_Cpp.codeAnalysis.maxConcurrentThreads":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.codeAnalysis.maxConcurrentThreads.markdownDescription%","default":null,"minimum":1,"maximum":32,"scope":"machine"},"C_Cpp.codeAnalysis.maxMemory":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.codeAnalysis.maxMemory.markdownDescription%","default":null,"minimum":256,"maximum":65536,"scope":"machine"},"C_Cpp.codeAnalysis.updateDelay":{"type":"number","default":2000,"markdownDescription":"%c_cpp.configuration.codeAnalysis.updateDelay.markdownDescription%","scope":"application","minimum":0,"maximum":6000},"C_Cpp.codeAnalysis.exclude":{"type":"object","markdownDescription":"%c_cpp.configuration.codeAnalysis.exclude.markdownDescription%","default":{},"additionalProperties":{"anyOf":[{"type":"boolean","markdownDescription":"%c_cpp.configuration.codeAnalysis.excludeBoolean.markdownDescription%"},{"type":"object","properties":{"when":{"type":"string","pattern":"\\w*\\$\\(basename\\)\\w*","default":"$(basename).ext","markdownDescription":"%c_cpp.configuration.codeAnalysis.excludeWhen.markdownDescription%"}}}]},"scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.codeAction.formatFixes":{"type":"boolean","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.formatFixes.markdownDescription%","default":true,"scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.codeAction.showClear":{"type":"string","description":"%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showClear.description%","enum":["None","AllOnly","AllAndAllType","AllAndAllTypeAndThis"],"enumDescriptions":["%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showClear.None.description%","%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showClear.AllOnly.description%","%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showClear.AllAndAllType.description%","%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showClear.AllAndAllTypeAndThis.description%"],"default":"AllAndAllTypeAndThis","scope":"application"},"C_Cpp.codeAnalysis.clangTidy.codeAction.showDisable":{"type":"boolean","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showDisable.markdownDescription%","default":true,"scope":"application"},"C_Cpp.codeAnalysis.clangTidy.codeAction.showDocumentation":{"type":"boolean","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.codeAction.showDocumentation.markdownDescription%","default":true,"scope":"application"},"C_Cpp.codeAnalysis.runAutomatically":{"type":"boolean","markdownDescription":"%c_cpp.configuration.codeAnalysis.runAutomatically.markdownDescription%","default":true,"scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.enabled":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.enabled.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.path":{"type":"string","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.path.markdownDescription%","scope":"machine-overridable"},"C_Cpp.codeAnalysis.clangTidy.config":{"type":"string","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.config.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.fallbackConfig":{"type":"string","markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.fallbackConfig.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.headerFilter":{"type":["string","null"],"default":null,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.headerFilter.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.args":{"type":"array","items":{"type":"string"},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.args.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.useBuildPath":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.useBuildPath.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.checks.enabled":{"type":"array","items":{"type":"string","enum":["*","abseil-*","abseil-cleanup-ctad","abseil-duration-*","abseil-duration-addition","abseil-duration-comparison","abseil-duration-conversion-cast","abseil-duration-division","abseil-duration-factory-*","abseil-duration-factory-float","abseil-duration-factory-scale","abseil-duration-subtraction","abseil-duration-unnecessary-conversion","abseil-faster-strsplit-delimiter","abseil-no-*","abseil-no-internal-dependencies","abseil-no-namespace","abseil-redundant-strcat-calls","abseil-str-cat-append","abseil-string-find-*","abseil-string-find-startswith","abseil-string-find-str-contains","abseil-time-*","abseil-time-comparison","abseil-time-subtraction","abseil-upgrade-duration-conversions","altera-*","altera-id-dependent-backward-branch","altera-kernel-name-restriction","altera-single-work-item-barrier","altera-struct-pack-align","altera-unroll-loops","android-*","android-cloexec-*","android-cloexec-accept","android-cloexec-accept4","android-cloexec-creat","android-cloexec-dup","android-cloexec-epoll-*","android-cloexec-epoll-create","android-cloexec-epoll-create1","android-cloexec-fopen","android-cloexec-inotify-*","android-cloexec-inotify-init","android-cloexec-inotify-init1","android-cloexec-memfd-create","android-cloexec-open","android-cloexec-pipe","android-cloexec-pipe2","android-cloexec-socket","android-comparison-in-temp-failure-retry","boost-use-to-string","bugprone-*","bugprone-argument-comment","bugprone-assert-side-effect","bugprone-assignment-in-if-condition","bugprone-bad-signal-to-kill-thread","bugprone-bool-pointer-implicit-conversion","bugprone-branch-clone","bugprone-copy-constructor-init","bugprone-dangling-handle","bugprone-dynamic-static-initializers","bugprone-easily-swappable-parameters","bugprone-empty-catch","bugprone-exception-escape","bugprone-fold-init-type","bugprone-forward-declaration-namespace","bugprone-forwarding-reference-overload","bugprone-implicit-widening-of-multiplication-result","bugprone-inaccurate-erase","bugprone-incorrect-roundings","bugprone-infinite-loop","bugprone-integer-division","bugprone-lambda-function-name","bugprone-macro-parentheses","bugprone-macro-repeated-side-effects","bugprone-misplaced-*","bugprone-misplaced-operator-in-strlen-in-alloc","bugprone-misplaced-pointer-arithmetic-in-alloc","bugprone-misplaced-widening-cast","bugprone-move-forwarding-reference","bugprone-multiple-*","bugprone-multiple-new-in-one-expression","bugprone-multiple-statement-macro","bugprone-narrowing-conversions","bugprone-no-escape","bugprone-non-zero-enum-to-bool-conversion","bugprone-not-null-terminated-result","bugprone-parent-virtual-call","bugprone-posix-return","bugprone-redundant-branch-condition","bugprone-reserved-identifier","bugprone-shared-ptr-array-mismatch","bugprone-signal-handler","bugprone-signed-char-misuse","bugprone-sizeof-*","bugprone-sizeof-container","bugprone-sizeof-expression","bugprone-spuriously-wake-up-functions","bugprone-standalone-empty","bugprone-string-*","bugprone-string-constructor","bugprone-string-integer-assignment","bugprone-string-literal-with-embedded-nul","bugprone-stringview-nullptr","bugprone-suspicious-*","bugprone-suspicious-enum-usage","bugprone-suspicious-include","bugprone-suspicious-memory-comparison","bugprone-suspicious-memset-usage","bugprone-suspicious-missing-comma","bugprone-suspicious-realloc-usage","bugprone-suspicious-semicolon","bugprone-suspicious-string-compare","bugprone-swapped-arguments","bugprone-switch-missing-default-case","bugprone-terminating-continue","bugprone-throw-keyword-missing","bugprone-too-small-loop-variable","bugprone-unchecked-optional-access","bugprone-undefined-memory-manipulation","bugprone-undelegated-constructor","bugprone-unhandled-*","bugprone-unhandled-exception-at-new","bugprone-unhandled-self-assignment","bugprone-unique-ptr-array-mismatch","bugprone-unused-raii","bugprone-unused-return-value","bugprone-use-after-move","bugprone-virtual-near-miss","cert-*","cert-con*","cert-con36-c","cert-con54-cpp","cert-dcl*","cert-dcl03-c","cert-dcl16-c","cert-dcl21-cpp","cert-dcl37-c","cert-dcl50-cpp","cert-dcl51-cpp","cert-dcl54-cpp","cert-dcl58-cpp","cert-dcl59-cpp","cert-env33-c","cert-err*","cert-err09-cpp","cert-err33-c","cert-err34-c","cert-err52-cpp","cert-err58-cpp","cert-err60-cpp","cert-err61-cpp","cert-exp42-c","cert-fio38-c","cert-flp*","cert-flp30-c","cert-flp37-c","cert-mem57-cpp","cert-msc*","cert-msc30-c","cert-msc32-c","cert-msc50-cpp","cert-msc51-cpp","cert-msc54-cpp","cert-oop*","cert-oop11-cpp","cert-oop54-cpp","cert-oop57-cpp","cert-oop58-cpp","cert-pos*","cert-pos44-c","cert-pos47-c","cert-sig30-c","cert-str34-c","clang-analyzer-*","clang-analyzer-core.*","clang-analyzer-core.CallAndMessage","clang-analyzer-core.DivideZero","clang-analyzer-core.DynamicTypePropagation","clang-analyzer-core.NonNullParamChecker","clang-analyzer-core.NullDereference","clang-analyzer-core.StackAddressEscape","clang-analyzer-core.UndefinedBinaryOperatorResult","clang-analyzer-core.uninitialized.*","clang-analyzer-core.uninitialized.ArraySubscript","clang-analyzer-core.uninitialized.Assign","clang-analyzer-core.uninitialized.Branch","clang-analyzer-core.uninitialized.CapturedBlockVariable","clang-analyzer-core.uninitialized.UndefReturn","clang-analyzer-core.VLASize","clang-analyzer-cplusplus.*","clang-analyzer-cplusplus.InnerPointer","clang-analyzer-cplusplus.Move","clang-analyzer-cplusplus.NewDelete","clang-analyzer-cplusplus.NewDeleteLeaks","clang-analyzer-deadcode.DeadStores","clang-analyzer-nullablity.*","clang-analyzer-nullability.NullableDereferenced","clang-analyzer-nullability.NullablePassedToNonnull","clang-analyzer-nullability.NullableReturnedFromNonnull","clang-analyzer-nullability.NullPassedToNonnull","clang-analyzer-nullability.NullReturnedFromNonnull","clang-analyzer-optin.*","clang-analyzer-optin.cplusplus.*","clang-analyzer-optin.cplusplus.UninitializedObject","clang-analyzer-optin.cplusplus.VirtualCall","clang-analyzer-optin.mpi.MPI-Checker","clang-analyzer-optin.osx.*","clang-analyzer-optin.osx.cocoa.localizability.*","clang-analyzer-optin.osx.cocoa.localizability.EmptyLocalizationContextChecker","clang-analyzer-optin.osx.cocoa.localizability.NonLocalizedStringChecker","clang-analyzer-optin.osx.OSObjectCStyleCast","clang-analyzer-optin.performance.*","clang-analyzer-optin.performance.GCDAntipattern","clang-analyzer-optin.performance.Padding","clang-analyzer-optin.portability.UnixAPI","clang-analyzer-osx.*","clang-analyzer-osx.API","clang-analyzer-osx.cocoa.*","clang-analyzer-osx.cocoa.AtSync","clang-analyzer-osx.cocoa.AutoreleaseWrite","clang-analyzer-osx.cocoa.ClassRelease","clang-analyzer-osx.cocoa.Dealloc","clang-analyzer-osx.cocoa.IncompatibleMethodTypes","clang-analyzer-osx.cocoa.Loops","clang-analyzer-osx.cocoa.MissingSuperCall","clang-analyzer-osx.cocoa.NilArg","clang-analyzer-osx.cocoa.NonNilReturnValue","clang-analyzer-osx.cocoa.NSAutoreleasePool","clang-analyzer-osx.cocoa.NSError","clang-analyzer-osx.cocoa.ObjCGenerics","clang-analyzer-osx.cocoa.RetainCount","clang-analyzer-osx.cocoa.RetainCountBase","clang-analyzer-osx.cocoa.RunLoopAutoreleaseLeak","clang-analyzer-osx.cocoa.SelfInit","clang-analyzer-osx.cocoa.SuperDealloc","clang-analyzer-osx.cocoa.UnusedIvars","clang-analyzer-osx.cocoa.VariadicMethodTypes","clang-analyzer-osx.coreFoundation.*","clang-analyzer-osx.coreFoundation.CFError","clang-analyzer-osx.coreFoundation.CFNumber","clang-analyzer-osx.coreFoundation.CFRetainRelease","clang-analyzer-osx.coreFoundation.containers.*","clang-analyzer-osx.coreFoundation.containers.OutOfBounds","clang-analyzer-osx.coreFoundation.containers.PointerSizedValues","clang-analyzer-osx.MIG","clang-analyzer-osx.NumberObjectConversion","clang-analyzer-osx.ObjCProperty","clang-analyzer-osx.OSObjectRetainCount","clang-analyzer-osx.SecKeychainAPI","clang-analyzer-security.*","clang-analyzer-security.FloatLoopCounter","clang-analyzer-security.insecureAPI.*","clang-analyzer-security.insecureAPI.bcmp","clang-analyzer-security.insecureAPI.bcopy","clang-analyzer-security.insecureAPI.bzero","clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling","clang-analyzer-security.insecureAPI.getpw","clang-analyzer-security.insecureAPI.gets","clang-analyzer-security.insecureAPI.mkstemp","clang-analyzer-security.insecureAPI.mktemp","clang-analyzer-security.insecureAPI.rand","clang-analyzer-security.insecureAPI.strcpy","clang-analyzer-security.insecureAPI.UncheckedReturn","clang-analyzer-security.insecureAPI.vfork","clang-analyzer-unix.*","clang-analyzer-unix.API","clang-analyzer-unix.cstring.*","clang-analyzer-unix.cstring.BadSizeArg","clang-analyzer-unix.cstring.NullArg","clang-analyzer-unix.Malloc","clang-analyzer-unix.MallocSizeof","clang-analyzer-unix.MismatchedDeallocator","clang-analyzer-unix.Vfork","clang-analyzer-valist.*","clang-analyzer-valist.CopyToSelf","clang-analyzer-valist.Uninitialized","clang-analyzer-valist.Unterminated","concurrency-*","concurrency-mt-unsafe","concurrency-thread-canceltype-asynchronous","cppcoreguidelines-*","cppcoreguidelines-avoid-*","cppcoreguidelines-avoid-c-arrays","cppcoreguidelines-avoid-capturing-lambda-coroutines","cppcoreguidelines-avoid-const-or-ref-data-members","cppcoreguidelines-avoid-do-while","cppcoreguidelines-avoid-goto","cppcoreguidelines-avoid-magic-numbers","cppcoreguidelines-avoid-non-const-global-variables","cppcoreguidelines-avoid-reference-coroutine-parameters","cppcoreguidelines-c-copy-assignment-signature","cppcoreguidelines-explicit-virtual-functions","cppcoreguidelines-init-variables","cppcoreguidelines-interfaces-global-init","cppcoreguidelines-macro-to-enum","cppcoreguidelines-macro-usage","cppcoreguidelines-misleading-capture-default-by-value","cppcoreguidelines-missing-std-forward","cppcoreguidelines-narrowing-conversions","cppcoreguidelines-no-malloc","cppcoreguidelines-non-private-member-variables-in-classes","cppcoreguidelines-owning-memory","cppcoreguidelines-prefer-member-initializer","cppcoreguidelines-pro-bounds-*","cppcoreguidelines-pro-bounds-array-to-pointer-decay","cppcoreguidelines-pro-bounds-constant-array-index","cppcoreguidelines-pro-bounds-pointer-arithmetic","cppcoreguidelines-pro-type-*","cppcoreguidelines-pro-type-const-cast","cppcoreguidelines-pro-type-cstyle-cast","cppcoreguidelines-pro-type-member-init","cppcoreguidelines-pro-type-reinterpret-cast","cppcoreguidelines-pro-type-static-cast-downcast","cppcoreguidelines-pro-type-union-access","cppcoreguidelines-pro-type-vararg","cppcoreguidelines-rvalue-reference-param-not-moved","cppcoreguidelines-slicing","cppcoreguidelines-special-member-functions","cppcoreguidelines-virtual-class-destructor","darwin-*","darwin-avoid-spinlock","darwin-dispatch-once-nonstatic","fuchsia-*","fuchsia-default-*","fuchsia-default-arguments-calls","fuchsia-default-arguments-declarations","fuchsia-header-anon-namespaces","fuchsia-multiple-inheritance","fuchsia-overloaded-operator","fuchsia-statically-constructed-objects","fuchsia-trailing-return","fuchsia-virtual-inheritance","google-*","google-build-*","google-build-explicit-make-pair","google-build-namespaces","google-build-using-namespace","google-default-arguments","google-explicit-constructor","google-global-names-in-headers","google-objc-*","google-objc-avoid-*","google-objc-avoid-nsobject-new","google-objc-avoid-throwing-exception","google-objc-function-naming","google-objc-global-variable-declaration","google-readability-*","google-readability-avoid-underscore-in-googletest-name","google-readability-braces-around-statements","google-readability-casting","google-readability-function-size","google-readability-namespace-comments","google-readability-todo","google-runtime-*","google-runtime-int","google-runtime-operator","google-upgrade-googletest-case","hicpp-*","hicpp-avoid-*","hicpp-avoid-c-arrays","hicpp-avoid-goto","hicpp-braces-around-statements","hicpp-deprecated-headers","hicpp-exception-baseclass","hicpp-explicit-conversions","hicpp-function-size","hicpp-invalid-access-moved","hicpp-member-init","hicpp-move-const-arg","hicpp-multiway-paths-covered","hicpp-named-parameter","hicpp-new-delete-operators","hicpp-no-*","hicpp-no-array-decay","hicpp-no-assembler","hicpp-no-malloc","hicpp-noexcept-move","hicpp-signed-bitwise","hicpp-special-member-functions","hicpp-static-assert","hicpp-undelegated-constructor","hicpp-uppercase-literal-suffix","hicpp-use-*","hicpp-use-auto","hicpp-use-emplace","hicpp-use-equals-*","hicpp-use-equals-default","hicpp-use-equals-delete","hicpp-use-noexcept","hicpp-use-nullptr","hicpp-use-override","hicpp-vararg","linuxkernel-must-use-errs","llvm-*","llvm-else-after-return","llvm-header-guard","llvm-include-order","llvm-namespace-comment","llvm-prefer-*","llvm-prefer-isa-or-dyn-cast-in-conditionals","llvm-prefer-register-over-unsigned","llvm-qualified-auto","llvm-twine-local","llvmlibc-*","llvmlibc-callee-namespace","llvmlibc-implementation-in-namespace","llvmlibc-inline-function-decl","llvmlibc-restrict-system-libc-headers","misc-*","misc-confusable-identifiers","misc-const-correctness","misc-definitions-in-headers","misc-header-include-cycle","misc-include-cleaner","misc-misleading-*","misc-misleading-bidirectional","misc-misleading-identifier","misc-misplaced-const","misc-new-delete-overloads","misc-no-recursion","misc-non-*","misc-non-copyable-objects","misc-non-private-member-variables-in-classes","misc-redundant-expression","misc-static-assert","misc-throw-by-value-catch-by-reference","misc-unconventional-assign-operator","misc-uniqueptr-reset-release","misc-unused-*","misc-unused-alias-decls","misc-unused-parameters","misc-unused-using-decls","misc-use-anonymous-namespace","modernize-*","modernize-avoid-*","modernize-avoid-bind","modernize-avoid-c-arrays","modernize-concat-nested-namespaces","modernize-deprecated-*","modernize-deprecated-headers","modernize-deprecated-ios-base-aliases","modernize-loop-convert","modernize-macro-to-enum","modernize-make-*","modernize-make-shared","modernize-make-unique","modernize-pass-by-value","modernize-raw-string-literal","modernize-redundant-void-arg","modernize-replace-*","modernize-replace-auto-ptr","modernize-replace-disallow-copy-and-assign-macro","modernize-replace-random-shuffle","modernize-return-braced-init-list","modernize-shrink-to-fit","modernize-type-traits","modernize-unary-static-assert","modernize-use-*","modernize-use-auto","modernize-use-bool-literals","modernize-use-default","modernize-use-default-member-init","modernize-use-emplace","modernize-use-equals-*","modernize-use-equals-default","modernize-use-equals-delete","modernize-use-nodiscard","modernize-use-noexcept","modernize-use-nullptr","modernize-use-override","modernize-use-std-print","modernize-use-trailing-return-type","modernize-use-transparent-functors","modernize-use-uncaught-exceptions","modernize-use-using","mpi-*","mpi-buffer-deref","mpi-type-mismatch","objc-*","objc-assert-equals","objc-avoid-nserror-init","objc-dealloc-in-category","objc-forbidden-subclassing","objc-missing-hash","objc-nsdate-formatter","objc-nsinvocation-argument-lifetime","objc-property-declaration","objc-super-self","openmp-*","openmp-exception-escape","openmp-use-default-none","performance-*","performance-avoid-endl","performance-faster-string-find","performance-for-range-copy","performance-implicit-conversion-in-loop","performance-inefficient-*","performance-inefficient-algorithm","performance-inefficient-string-concatenation","performance-inefficient-vector-operation","performance-move-*","performance-move-const-arg","performance-move-constructor-init","performance-no-*","performance-no-automatic-move","performance-no-int-to-ptr","performance-noexcept-*","performance-noexcept-destructor","performance-noexcept-move-constructor","performance-noexcept-swap","performance-trivially-destructible","performance-type-promotion-in-math-fn","performance-unnecessary-*","performance-unnecessary-copy-initialization","performance-unnecessary-value-param","portability-*","portability-restrict-system-includes","portability-simd-intrinsics","portability-std-allocator-const","readability-*","readability-avoid-*","readability-avoid-const-params-in-decls","readability-avoid-unconditional-preprocessor-if","readability-braces-around-statements","readability-const-return-type","readability-container-*","readability-container-contains","readability-container-data-pointer","readability-container-size-empty","readability-convert-member-functions-to-static","readability-delete-null-pointer","readability-duplicate-include","readability-else-after-return","readability-function-*","readability-function-cognitive-complexity","readability-function-size","readability-identifier-*","readability-identifier-length","readability-identifier-naming","readability-implicit-bool-conversion","readability-inconsistent-declaration-parameter-name","readability-isolate-declaration","readability-magic-numbers","readability-make-member-function-const","readability-misleading-indentation","readability-misplaced-array-index","readability-named-parameter","readability-non-const-parameter","readability-operators-representation","readability-qualified-auto","readability-redundant-*","readability-redundant-access-specifiers","readability-redundant-control-flow","readability-redundant-declaration","readability-redundant-function-ptr-dereference","readability-redundant-member-init","readability-redundant-preprocessor","readability-redundant-smartptr-get","readability-redundant-string-*","readability-redundant-string-cstr","readability-redundant-string-init","readability-simplify-*","readability-simplify-boolean-expr","readability-simplify-subscript-expr","readability-static-*","readability-static-accessed-through-instance","readability-static-definition-in-anonymous-namespace","readability-string-compare","readability-suspicious-call-argument","readability-uniqueptr-delete-release","readability-uppercase-literal-suffix","readability-use-anyofallof","zircon-temporary-objects"]},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.checks.enabled.markdownDescription%","scope":"resource"},"C_Cpp.codeAnalysis.clangTidy.checks.disabled":{"type":"array","items":{"type":"string","enum":["*","abseil-*","abseil-cleanup-ctad","abseil-duration-*","abseil-duration-addition","abseil-duration-comparison","abseil-duration-conversion-cast","abseil-duration-division","abseil-duration-factory-*","abseil-duration-factory-float","abseil-duration-factory-scale","abseil-duration-subtraction","abseil-duration-unnecessary-conversion","abseil-faster-strsplit-delimiter","abseil-no-*","abseil-no-internal-dependencies","abseil-no-namespace","abseil-redundant-strcat-calls","abseil-str-cat-append","abseil-string-find-*","abseil-string-find-startswith","abseil-string-find-str-contains","abseil-time-*","abseil-time-comparison","abseil-time-subtraction","abseil-upgrade-duration-conversions","altera-*","altera-id-dependent-backward-branch","altera-kernel-name-restriction","altera-single-work-item-barrier","altera-struct-pack-align","altera-unroll-loops","android-*","android-cloexec-*","android-cloexec-accept","android-cloexec-accept4","android-cloexec-creat","android-cloexec-dup","android-cloexec-epoll-*","android-cloexec-epoll-create","android-cloexec-epoll-create1","android-cloexec-fopen","android-cloexec-inotify-*","android-cloexec-inotify-init","android-cloexec-inotify-init1","android-cloexec-memfd-create","android-cloexec-open","android-cloexec-pipe","android-cloexec-pipe2","android-cloexec-socket","android-comparison-in-temp-failure-retry","boost-use-to-string","bugprone-*","bugprone-argument-comment","bugprone-assert-side-effect","bugprone-assignment-in-if-condition","bugprone-bad-signal-to-kill-thread","bugprone-bool-pointer-implicit-conversion","bugprone-branch-clone","bugprone-copy-constructor-init","bugprone-dangling-handle","bugprone-dynamic-static-initializers","bugprone-easily-swappable-parameters","bugprone-empty-catch","bugprone-exception-escape","bugprone-fold-init-type","bugprone-forward-declaration-namespace","bugprone-forwarding-reference-overload","bugprone-implicit-widening-of-multiplication-result","bugprone-inaccurate-erase","bugprone-incorrect-roundings","bugprone-infinite-loop","bugprone-integer-division","bugprone-lambda-function-name","bugprone-macro-parentheses","bugprone-macro-repeated-side-effects","bugprone-misplaced-*","bugprone-misplaced-operator-in-strlen-in-alloc","bugprone-misplaced-pointer-arithmetic-in-alloc","bugprone-misplaced-widening-cast","bugprone-move-forwarding-reference","bugprone-multiple-*","bugprone-multiple-new-in-one-expression","bugprone-multiple-statement-macro","bugprone-narrowing-conversions","bugprone-no-escape","bugprone-non-zero-enum-to-bool-conversion","bugprone-not-null-terminated-result","bugprone-parent-virtual-call","bugprone-posix-return","bugprone-redundant-branch-condition","bugprone-reserved-identifier","bugprone-shared-ptr-array-mismatch","bugprone-signal-handler","bugprone-signed-char-misuse","bugprone-sizeof-*","bugprone-sizeof-container","bugprone-sizeof-expression","bugprone-spuriously-wake-up-functions","bugprone-standalone-empty","bugprone-string-*","bugprone-string-constructor","bugprone-string-integer-assignment","bugprone-string-literal-with-embedded-nul","bugprone-stringview-nullptr","bugprone-suspicious-*","bugprone-suspicious-enum-usage","bugprone-suspicious-include","bugprone-suspicious-memory-comparison","bugprone-suspicious-memset-usage","bugprone-suspicious-missing-comma","bugprone-suspicious-realloc-usage","bugprone-suspicious-semicolon","bugprone-suspicious-string-compare","bugprone-swapped-arguments","bugprone-switch-missing-default-case","bugprone-terminating-continue","bugprone-throw-keyword-missing","bugprone-too-small-loop-variable","bugprone-unchecked-optional-access","bugprone-undefined-memory-manipulation","bugprone-undelegated-constructor","bugprone-unhandled-*","bugprone-unhandled-exception-at-new","bugprone-unhandled-self-assignment","bugprone-unique-ptr-array-mismatch","bugprone-unused-raii","bugprone-unused-return-value","bugprone-use-after-move","bugprone-virtual-near-miss","cert-*","cert-con*","cert-con36-c","cert-con54-cpp","cert-dcl*","cert-dcl03-c","cert-dcl16-c","cert-dcl21-cpp","cert-dcl37-c","cert-dcl50-cpp","cert-dcl51-cpp","cert-dcl54-cpp","cert-dcl58-cpp","cert-dcl59-cpp","cert-env33-c","cert-err*","cert-err09-cpp","cert-err33-c","cert-err34-c","cert-err52-cpp","cert-err58-cpp","cert-err60-cpp","cert-err61-cpp","cert-exp42-c","cert-fio38-c","cert-flp*","cert-flp30-c","cert-flp37-c","cert-mem57-cpp","cert-msc*","cert-msc30-c","cert-msc32-c","cert-msc50-cpp","cert-msc51-cpp","cert-msc54-cpp","cert-oop*","cert-oop11-cpp","cert-oop54-cpp","cert-oop57-cpp","cert-oop58-cpp","cert-pos*","cert-pos44-c","cert-pos47-c","cert-sig30-c","cert-str34-c","clang-analyzer-*","clang-analyzer-core.*","clang-analyzer-core.CallAndMessage","clang-analyzer-core.DivideZero","clang-analyzer-core.DynamicTypePropagation","clang-analyzer-core.NonNullParamChecker","clang-analyzer-core.NullDereference","clang-analyzer-core.StackAddressEscape","clang-analyzer-core.UndefinedBinaryOperatorResult","clang-analyzer-core.uninitialized.*","clang-analyzer-core.uninitialized.ArraySubscript","clang-analyzer-core.uninitialized.Assign","clang-analyzer-core.uninitialized.Branch","clang-analyzer-core.uninitialized.CapturedBlockVariable","clang-analyzer-core.uninitialized.UndefReturn","clang-analyzer-core.VLASize","clang-analyzer-cplusplus.*","clang-analyzer-cplusplus.InnerPointer","clang-analyzer-cplusplus.Move","clang-analyzer-cplusplus.NewDelete","clang-analyzer-cplusplus.NewDeleteLeaks","clang-analyzer-deadcode.DeadStores","clang-analyzer-nullablity.*","clang-analyzer-nullability.NullableDereferenced","clang-analyzer-nullability.NullablePassedToNonnull","clang-analyzer-nullability.NullableReturnedFromNonnull","clang-analyzer-nullability.NullPassedToNonnull","clang-analyzer-nullability.NullReturnedFromNonnull","clang-analyzer-optin.*","clang-analyzer-optin.cplusplus.*","clang-analyzer-optin.cplusplus.UninitializedObject","clang-analyzer-optin.cplusplus.VirtualCall","clang-analyzer-optin.mpi.MPI-Checker","clang-analyzer-optin.osx.*","clang-analyzer-optin.osx.cocoa.localizability.*","clang-analyzer-optin.osx.cocoa.localizability.EmptyLocalizationContextChecker","clang-analyzer-optin.osx.cocoa.localizability.NonLocalizedStringChecker","clang-analyzer-optin.osx.OSObjectCStyleCast","clang-analyzer-optin.performance.*","clang-analyzer-optin.performance.GCDAntipattern","clang-analyzer-optin.performance.Padding","clang-analyzer-optin.portability.UnixAPI","clang-analyzer-osx.*","clang-analyzer-osx.API","clang-analyzer-osx.cocoa.*","clang-analyzer-osx.cocoa.AtSync","clang-analyzer-osx.cocoa.AutoreleaseWrite","clang-analyzer-osx.cocoa.ClassRelease","clang-analyzer-osx.cocoa.Dealloc","clang-analyzer-osx.cocoa.IncompatibleMethodTypes","clang-analyzer-osx.cocoa.Loops","clang-analyzer-osx.cocoa.MissingSuperCall","clang-analyzer-osx.cocoa.NilArg","clang-analyzer-osx.cocoa.NonNilReturnValue","clang-analyzer-osx.cocoa.NSAutoreleasePool","clang-analyzer-osx.cocoa.NSError","clang-analyzer-osx.cocoa.ObjCGenerics","clang-analyzer-osx.cocoa.RetainCount","clang-analyzer-osx.cocoa.RetainCountBase","clang-analyzer-osx.cocoa.RunLoopAutoreleaseLeak","clang-analyzer-osx.cocoa.SelfInit","clang-analyzer-osx.cocoa.SuperDealloc","clang-analyzer-osx.cocoa.UnusedIvars","clang-analyzer-osx.cocoa.VariadicMethodTypes","clang-analyzer-osx.coreFoundation.*","clang-analyzer-osx.coreFoundation.CFError","clang-analyzer-osx.coreFoundation.CFNumber","clang-analyzer-osx.coreFoundation.CFRetainRelease","clang-analyzer-osx.coreFoundation.containers.*","clang-analyzer-osx.coreFoundation.containers.OutOfBounds","clang-analyzer-osx.coreFoundation.containers.PointerSizedValues","clang-analyzer-osx.MIG","clang-analyzer-osx.NumberObjectConversion","clang-analyzer-osx.ObjCProperty","clang-analyzer-osx.OSObjectRetainCount","clang-analyzer-osx.SecKeychainAPI","clang-analyzer-security.*","clang-analyzer-security.FloatLoopCounter","clang-analyzer-security.insecureAPI.*","clang-analyzer-security.insecureAPI.bcmp","clang-analyzer-security.insecureAPI.bcopy","clang-analyzer-security.insecureAPI.bzero","clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling","clang-analyzer-security.insecureAPI.getpw","clang-analyzer-security.insecureAPI.gets","clang-analyzer-security.insecureAPI.mkstemp","clang-analyzer-security.insecureAPI.mktemp","clang-analyzer-security.insecureAPI.rand","clang-analyzer-security.insecureAPI.strcpy","clang-analyzer-security.insecureAPI.UncheckedReturn","clang-analyzer-security.insecureAPI.vfork","clang-analyzer-unix.*","clang-analyzer-unix.API","clang-analyzer-unix.cstring.*","clang-analyzer-unix.cstring.BadSizeArg","clang-analyzer-unix.cstring.NullArg","clang-analyzer-unix.Malloc","clang-analyzer-unix.MallocSizeof","clang-analyzer-unix.MismatchedDeallocator","clang-analyzer-unix.Vfork","clang-analyzer-valist.*","clang-analyzer-valist.CopyToSelf","clang-analyzer-valist.Uninitialized","clang-analyzer-valist.Unterminated","concurrency-*","concurrency-mt-unsafe","concurrency-thread-canceltype-asynchronous","cppcoreguidelines-*","cppcoreguidelines-avoid-*","cppcoreguidelines-avoid-c-arrays","cppcoreguidelines-avoid-capturing-lambda-coroutines","cppcoreguidelines-avoid-const-or-ref-data-members","cppcoreguidelines-avoid-do-while","cppcoreguidelines-avoid-goto","cppcoreguidelines-avoid-magic-numbers","cppcoreguidelines-avoid-non-const-global-variables","cppcoreguidelines-avoid-reference-coroutine-parameters","cppcoreguidelines-c-copy-assignment-signature","cppcoreguidelines-explicit-virtual-functions","cppcoreguidelines-init-variables","cppcoreguidelines-interfaces-global-init","cppcoreguidelines-macro-to-enum","cppcoreguidelines-macro-usage","cppcoreguidelines-misleading-capture-default-by-value","cppcoreguidelines-missing-std-forward","cppcoreguidelines-narrowing-conversions","cppcoreguidelines-no-malloc","cppcoreguidelines-non-private-member-variables-in-classes","cppcoreguidelines-owning-memory","cppcoreguidelines-prefer-member-initializer","cppcoreguidelines-pro-bounds-*","cppcoreguidelines-pro-bounds-array-to-pointer-decay","cppcoreguidelines-pro-bounds-constant-array-index","cppcoreguidelines-pro-bounds-pointer-arithmetic","cppcoreguidelines-pro-type-*","cppcoreguidelines-pro-type-const-cast","cppcoreguidelines-pro-type-cstyle-cast","cppcoreguidelines-pro-type-member-init","cppcoreguidelines-pro-type-reinterpret-cast","cppcoreguidelines-pro-type-static-cast-downcast","cppcoreguidelines-pro-type-union-access","cppcoreguidelines-pro-type-vararg","cppcoreguidelines-rvalue-reference-param-not-moved","cppcoreguidelines-slicing","cppcoreguidelines-special-member-functions","cppcoreguidelines-virtual-class-destructor","darwin-*","darwin-avoid-spinlock","darwin-dispatch-once-nonstatic","fuchsia-*","fuchsia-default-*","fuchsia-default-arguments-calls","fuchsia-default-arguments-declarations","fuchsia-header-anon-namespaces","fuchsia-multiple-inheritance","fuchsia-overloaded-operator","fuchsia-statically-constructed-objects","fuchsia-trailing-return","fuchsia-virtual-inheritance","google-*","google-build-*","google-build-explicit-make-pair","google-build-namespaces","google-build-using-namespace","google-default-arguments","google-explicit-constructor","google-global-names-in-headers","google-objc-*","google-objc-avoid-*","google-objc-avoid-nsobject-new","google-objc-avoid-throwing-exception","google-objc-function-naming","google-objc-global-variable-declaration","google-readability-*","google-readability-avoid-underscore-in-googletest-name","google-readability-braces-around-statements","google-readability-casting","google-readability-function-size","google-readability-namespace-comments","google-readability-todo","google-runtime-*","google-runtime-int","google-runtime-operator","google-upgrade-googletest-case","hicpp-*","hicpp-avoid-*","hicpp-avoid-c-arrays","hicpp-avoid-goto","hicpp-braces-around-statements","hicpp-deprecated-headers","hicpp-exception-baseclass","hicpp-explicit-conversions","hicpp-function-size","hicpp-invalid-access-moved","hicpp-member-init","hicpp-move-const-arg","hicpp-multiway-paths-covered","hicpp-named-parameter","hicpp-new-delete-operators","hicpp-no-*","hicpp-no-array-decay","hicpp-no-assembler","hicpp-no-malloc","hicpp-noexcept-move","hicpp-signed-bitwise","hicpp-special-member-functions","hicpp-static-assert","hicpp-undelegated-constructor","hicpp-uppercase-literal-suffix","hicpp-use-*","hicpp-use-auto","hicpp-use-emplace","hicpp-use-equals-*","hicpp-use-equals-default","hicpp-use-equals-delete","hicpp-use-noexcept","hicpp-use-nullptr","hicpp-use-override","hicpp-vararg","linuxkernel-must-use-errs","llvm-*","llvm-else-after-return","llvm-header-guard","llvm-include-order","llvm-namespace-comment","llvm-prefer-*","llvm-prefer-isa-or-dyn-cast-in-conditionals","llvm-prefer-register-over-unsigned","llvm-qualified-auto","llvm-twine-local","llvmlibc-*","llvmlibc-callee-namespace","llvmlibc-implementation-in-namespace","llvmlibc-inline-function-decl","llvmlibc-restrict-system-libc-headers","misc-*","misc-confusable-identifiers","misc-const-correctness","misc-definitions-in-headers","misc-header-include-cycle","misc-include-cleaner","misc-misleading-*","misc-misleading-bidirectional","misc-misleading-identifier","misc-misplaced-const","misc-new-delete-overloads","misc-no-recursion","misc-non-*","misc-non-copyable-objects","misc-non-private-member-variables-in-classes","misc-redundant-expression","misc-static-assert","misc-throw-by-value-catch-by-reference","misc-unconventional-assign-operator","misc-uniqueptr-reset-release","misc-unused-*","misc-unused-alias-decls","misc-unused-parameters","misc-unused-using-decls","misc-use-anonymous-namespace","modernize-*","modernize-avoid-*","modernize-avoid-bind","modernize-avoid-c-arrays","modernize-concat-nested-namespaces","modernize-deprecated-*","modernize-deprecated-headers","modernize-deprecated-ios-base-aliases","modernize-loop-convert","modernize-macro-to-enum","modernize-make-*","modernize-make-shared","modernize-make-unique","modernize-pass-by-value","modernize-raw-string-literal","modernize-redundant-void-arg","modernize-replace-*","modernize-replace-auto-ptr","modernize-replace-disallow-copy-and-assign-macro","modernize-replace-random-shuffle","modernize-return-braced-init-list","modernize-shrink-to-fit","modernize-type-traits","modernize-unary-static-assert","modernize-use-*","modernize-use-auto","modernize-use-bool-literals","modernize-use-default","modernize-use-default-member-init","modernize-use-emplace","modernize-use-equals-*","modernize-use-equals-default","modernize-use-equals-delete","modernize-use-nodiscard","modernize-use-noexcept","modernize-use-nullptr","modernize-use-override","modernize-use-std-print","modernize-use-trailing-return-type","modernize-use-transparent-functors","modernize-use-uncaught-exceptions","modernize-use-using","mpi-*","mpi-buffer-deref","mpi-type-mismatch","objc-*","objc-assert-equals","objc-avoid-nserror-init","objc-dealloc-in-category","objc-forbidden-subclassing","objc-missing-hash","objc-nsdate-formatter","objc-nsinvocation-argument-lifetime","objc-property-declaration","objc-super-self","openmp-*","openmp-exception-escape","openmp-use-default-none","performance-*","performance-avoid-endl","performance-faster-string-find","performance-for-range-copy","performance-implicit-conversion-in-loop","performance-inefficient-*","performance-inefficient-algorithm","performance-inefficient-string-concatenation","performance-inefficient-vector-operation","performance-move-*","performance-move-const-arg","performance-move-constructor-init","performance-no-*","performance-no-automatic-move","performance-no-int-to-ptr","performance-noexcept-*","performance-noexcept-destructor","performance-noexcept-move-constructor","performance-noexcept-swap","performance-trivially-destructible","performance-type-promotion-in-math-fn","performance-unnecessary-*","performance-unnecessary-copy-initialization","performance-unnecessary-value-param","portability-*","portability-restrict-system-includes","portability-simd-intrinsics","portability-std-allocator-const","readability-*","readability-avoid-*","readability-avoid-const-params-in-decls","readability-avoid-unconditional-preprocessor-if","readability-braces-around-statements","readability-const-return-type","readability-container-*","readability-container-contains","readability-container-data-pointer","readability-container-size-empty","readability-convert-member-functions-to-static","readability-delete-null-pointer","readability-duplicate-include","readability-else-after-return","readability-function-*","readability-function-cognitive-complexity","readability-function-size","readability-identifier-*","readability-identifier-length","readability-identifier-naming","readability-implicit-bool-conversion","readability-inconsistent-declaration-parameter-name","readability-isolate-declaration","readability-magic-numbers","readability-make-member-function-const","readability-misleading-indentation","readability-misplaced-array-index","readability-named-parameter","readability-non-const-parameter","readability-operators-representation","readability-qualified-auto","readability-redundant-*","readability-redundant-access-specifiers","readability-redundant-control-flow","readability-redundant-declaration","readability-redundant-function-ptr-dereference","readability-redundant-member-init","readability-redundant-preprocessor","readability-redundant-smartptr-get","readability-redundant-string-*","readability-redundant-string-cstr","readability-redundant-string-init","readability-simplify-*","readability-simplify-boolean-expr","readability-simplify-subscript-expr","readability-static-*","readability-static-accessed-through-instance","readability-static-definition-in-anonymous-namespace","readability-string-compare","readability-suspicious-call-argument","readability-uniqueptr-delete-release","readability-uppercase-literal-suffix","readability-use-anyofallof","zircon-temporary-objects"]},"uniqueItems":true,"markdownDescription":"%c_cpp.configuration.codeAnalysis.clangTidy.checks.disabled.markdownDescription%","scope":"resource"}}},{"title":"%c_cpp.subheaders.debugging.title%","properties":{"C_Cpp.debugger.useBacktickCommandSubstitution":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.debugger.useBacktickCommandSubstitution.markdownDescription%","scope":"window"},"C_Cpp.sshTargetsView":{"type":"string","enum":["enabled","disabled","default"],"default":"default","description":"%c_cpp.configuration.sshTargetsView.description%","scope":"window"},"C_Cpp.debugShortcut":{"type":"boolean","default":true,"description":"%c_cpp.configuration.debugShortcut.description%","scope":"resource"}}},{"title":"%c_cpp.subheaders.resourceManagement.title%","properties":{"C_Cpp.references.maxConcurrentThreads":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.references.maxConcurrentThreads.markdownDescription%","default":null,"minimum":1,"maximum":32,"scope":"machine"},"C_Cpp.references.maxCachedProcesses":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.references.maxCachedProcesses.markdownDescription%","default":0,"minimum":0,"maximum":32,"scope":"machine"},"C_Cpp.references.maxMemory":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.references.maxMemory.markdownDescription%","default":null,"minimum":256,"maximum":65536,"scope":"machine"},"C_Cpp.intelliSenseCachePath":{"type":"string","markdownDescription":"%c_cpp.configuration.intelliSenseCachePath.markdownDescription%","scope":"machine-overridable"},"C_Cpp.intelliSenseCacheSize":{"type":"number","default":5120,"markdownDescription":"%c_cpp.configuration.intelliSenseCacheSize.markdownDescription%","scope":"machine-overridable","minimum":0},"C_Cpp.intelliSenseMemoryLimit":{"type":"number","default":4096,"markdownDescription":"%c_cpp.configuration.intelliSenseMemoryLimit.markdownDescription%","scope":"machine-overridable","minimum":256,"maximum":16384},"C_Cpp.maxConcurrentThreads":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.maxConcurrentThreads.markdownDescription%","default":null,"minimum":1,"maximum":32,"scope":"machine"},"C_Cpp.maxCachedProcesses":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.maxCachedProcesses.markdownDescription%","default":null,"minimum":0,"maximum":256,"scope":"machine"},"C_Cpp.maxMemory":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.maxMemory.markdownDescription%","default":null,"minimum":256,"maximum":65536,"scope":"machine"},"C_Cpp.intelliSense.maxCachedProcesses":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.intelliSense.maxCachedProcesses.markdownDescription%","default":null,"minimum":2,"maximum":128,"scope":"machine"},"C_Cpp.intelliSense.maxMemory":{"type":["integer","null"],"markdownDescription":"%c_cpp.configuration.intelliSense.maxMemory.markdownDescription%","default":null,"minimum":256,"maximum":65536,"scope":"machine"}}},{"title":"%c_cpp.subheaders.miscellaneous.title%","properties":{"C_Cpp.vcpkg.enabled":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.vcpkg.enabled.markdownDescription%","scope":"resource"},"C_Cpp.loggingLevel":{"type":"string","enum":["None","Error","Warning","Information","Debug"],"default":"Error","markdownDescription":"%c_cpp.configuration.loggingLevel.markdownDescription%","scope":"window"},"C_Cpp.autoAddFileAssociations":{"type":"boolean","default":true,"markdownDescription":"%c_cpp.configuration.autoAddFileAssociations.markdownDescription%","scope":"window"},"C_Cpp.preferredPathSeparator":{"type":"string","enum":["Forward Slash","Backslash"],"default":"Forward Slash","markdownDescription":"%c_cpp.configuration.preferredPathSeparator.markdownDescription%","scope":"machine-overridable"},"C_Cpp.updateChannel":{"type":"string","enum":["Default","Insiders"],"default":"Default","markdownDescription":"%c_cpp.configuration.updateChannel.markdownDescription%","scope":"application","deprecationMessage":"%c_cpp.configuration.updateChannel.deprecationMessage%"},"C_Cpp.experimentalFeatures":{"type":"string","enum":["enabled","disabled"],"default":"disabled","description":"%c_cpp.configuration.experimentalFeatures.description%","scope":"window"},"C_Cpp.caseSensitiveFileSupport":{"type":"string","enum":["default","enabled"],"default":"default","markdownDescription":"%c_cpp.configuration.caseSensitiveFileSupport.markdownDescription%","scope":"window"},"C_Cpp.addNodeAddonIncludePaths":{"type":"boolean","default":false,"markdownDescription":"%c_cpp.configuration.addNodeAddonIncludePaths.markdownDescription%","scope":"application"}}}],"jsonValidation":[{"fileMatch":"c_cpp_properties.json","url":"cpptools-schema:///c_cpp_properties.schema.json"}],"configurationDefaults":{"[cpp]":{"editor.wordBasedSuggestions":"off","editor.suggest.insertMode":"replace","editor.semanticHighlighting.enabled":true},"[cuda-cpp]":{"editor.wordBasedSuggestions":"off","editor.suggest.insertMode":"replace","editor.semanticHighlighting.enabled":true},"[c]":{"editor.wordBasedSuggestions":"off","editor.suggest.insertMode":"replace","editor.semanticHighlighting.enabled":true}},"semanticTokenTypes":[{"id":"referenceType","superType":"class","description":"%c_cpp.semanticTokenTypes.referenceType.description%"},{"id":"cliProperty","superType":"property","description":"%c_cpp.semanticTokenTypes.cliProperty.description%"},{"id":"genericType","superType":"class","description":"%c_cpp.semanticTokenTypes.genericType.description%"},{"id":"valueType","superType":"class","description":"%c_cpp.semanticTokenTypes.valueType.description%"},{"id":"templateFunction","superType":"function","description":"%c_cpp.semanticTokenTypes.templateFunction.description%"},{"id":"templateType","superType":"class","description":"%c_cpp.semanticTokenTypes.templateType.description%"},{"id":"operatorOverload","superType":"operator","description":"%c_cpp.semanticTokenTypes.operatorOverload.description%"},{"id":"memberOperatorOverload","superType":"operator","description":"%c_cpp.semanticTokenTypes.memberOperatorOverload.description%"},{"id":"newOperator","superType":"operator","description":"%c_cpp.semanticTokenTypes.newOperator.description%"},{"id":"customLiteral","superType":"number","description":"%c_cpp.semanticTokenTypes.customLiteral.description%"},{"id":"numberLiteral","superType":"number","description":"%c_cpp.semanticTokenTypes.numberLiteral.description%"},{"id":"stringLiteral","superType":"string","description":"%c_cpp.semanticTokenTypes.stringLiteral.description%"}],"semanticTokenModifiers":[{"id":"global","description":"%c_cpp.semanticTokenModifiers.global.description%"},{"id":"local","description":"%c_cpp.semanticTokenModifiers.local.description%"}],"semanticTokenScopes":[{"language":"c","scopes":{"namespace":["entity.name.namespace.c"],"type":["entity.name.type.c"],"type.defaultLibrary":["support.type.c"],"struct":["storage.type.struct.c"],"class":["entity.name.type.class.c"],"class.defaultLibrary":["support.class.c"],"interface":["entity.name.type.interface.c"],"enum":["entity.name.type.enum.c"],"function":["entity.name.function.c"],"function.defaultLibrary":["support.function.c"],"method":["entity.name.function.member.c"],"variable":["variable.other.readwrite.c","entity.name.variable.c"],"variable.readonly":["variable.other.constant.c"],"variable.readonly.defaultLibrary":["support.constant.c"],"parameter":["variable.parameter.c"],"property":["variable.other.property.c"],"property.readonly":["variable.other.constant.property.c"],"enumMember":["variable.other.enummember.c"],"event":["variable.other.event.c"],"label":["entity.name.label.c"],"variable.global":["variable.other.global.c"],"variable.local":["variable.other.local.c"],"property.static":["variable.other.property.static.c"],"method.static":["entity.name.function.member.static.c"],"macro":["entity.name.function.preprocessor.c","entity.name.function.macro.c"],"referenceType":["entity.name.type.class.reference.c"],"cliProperty":["variable.other.property.cli.c"],"genericType":["entity.name.type.class.generic.c"],"valueType":["entity.name.type.class.value.c"],"templateFunction":["entity.name.function.templated.c"],"templateType":["entity.name.type.class.templated.c"],"operatorOverload":["entity.name.function.operator.c"],"memberOperatorOverload":["entity.name.function.operator.member.c"],"newOperator":["keyword.operator.new.c"],"numberLiteral":["entity.name.operator.custom-literal.number.c"],"customLiteral":["entity.name.operator.custom-literal.c"],"stringLiteral":["entity.name.operator.custom-literal.string.c"]}},{"language":"cpp","scopes":{"namespace":["entity.name.namespace.cpp"],"type":["entity.name.type.cpp"],"type.defaultLibrary":["support.type.cpp"],"struct":["storage.type.struct.cpp"],"class":["entity.name.type.class.cpp"],"class.defaultLibrary":["support.class.cpp"],"interface":["entity.name.type.interface.cpp"],"enum":["entity.name.type.enum.cpp"],"function":["entity.name.function.cpp"],"function.defaultLibrary":["support.function.cpp"],"method":["entity.name.function.member.cpp"],"variable":["variable.other.readwrite.cpp","entity.name.variable.cpp"],"variable.readonly":["variable.other.constant.cpp"],"variable.readonly.defaultLibrary":["support.constant.cpp"],"parameter":["variable.parameter.cpp"],"property":["variable.other.property.cpp"],"property.readonly":["variable.other.constant.property.cpp"],"enumMember":["variable.other.enummember.cpp"],"event":["variable.other.event.cpp"],"label":["entity.name.label.cpp"],"variable.global":["variable.other.global.cpp"],"variable.local":["variable.other.local.cpp"],"property.static":["variable.other.property.static.cpp"],"method.static":["entity.name.function.member.static.cpp"],"macro":["entity.name.function.preprocessor.cpp","entity.name.function.macro.cpp"],"referenceType":["entity.name.type.class.reference.cpp"],"cliProperty":["variable.other.property.cli.cpp"],"genericType":["entity.name.type.class.generic.cpp"],"valueType":["entity.name.type.class.value.cpp"],"templateFunction":["entity.name.function.templated.cpp"],"templateType":["entity.name.type.class.templated.cpp"],"operatorOverload":["entity.name.function.operator.cpp"],"memberOperatorOverload":["entity.name.function.operator.member.cpp"],"newOperator":["keyword.operator.new.cpp"],"numberLiteral":["entity.name.operator.custom-literal.number.cpp"],"customLiteral":["entity.name.operator.custom-literal.cpp"],"stringLiteral":["entity.name.operator.custom-literal.string.cpp"]}},{"language":"cuda-cpp","scopes":{"namespace":["entity.name.namespace.cuda-cpp"],"type":["entity.name.type.cuda-cpp"],"type.defaultLibrary":["support.type.cuda-cpp"],"struct":["storage.type.struct.cuda-cpp"],"class":["entity.name.type.class.cuda-cpp"],"class.defaultLibrary":["support.class.cuda-cpp"],"interface":["entity.name.type.interface.cuda-cpp"],"enum":["entity.name.type.enum.cuda-cpp"],"function":["entity.name.function.cuda-cpp"],"function.defaultLibrary":["support.function.cuda-cpp"],"method":["entity.name.function.member.cuda-cpp"],"variable":["variable.other.readwrite.cuda-cpp","entity.name.variable.cuda-cpp"],"variable.readonly":["variable.other.constant.cuda-cpp"],"variable.readonly.defaultLibrary":["support.constant.cuda-cpp"],"parameter":["variable.parameter.cuda-cpp"],"property":["variable.other.property.cuda-cpp"],"property.readonly":["variable.other.constant.property.cuda-cpp"],"enumMember":["variable.other.enummember.cuda-cpp"],"event":["variable.other.event.cuda-cpp"],"label":["entity.name.label.cuda-cpp"],"variable.global":["variable.other.global.cuda-cpp"],"variable.local":["variable.other.local.cuda-cpp"],"property.static":["variable.other.property.static.cuda-cpp"],"method.static":["entity.name.function.member.static.cuda-cpp"],"macro":["entity.name.function.preprocessor.cuda-cpp","entity.name.function.macro.cuda-cpp"],"referenceType":["entity.name.type.class.reference.cuda-cpp"],"cliProperty":["variable.other.property.cli.cuda-cpp"],"genericType":["entity.name.type.class.generic.cuda-cpp"],"valueType":["entity.name.type.class.value.cuda-cpp"],"templateFunction":["entity.name.function.templated.cuda-cpp"],"templateType":["entity.name.type.class.templated.cuda-cpp"],"operatorOverload":["entity.name.function.operator.cuda-cpp"],"memberOperatorOverload":["entity.name.function.operator.member.cuda-cpp"],"newOperator":["keyword.operator.new.cuda-cpp"],"numberLiteral":["entity.name.operator.custom-literal.number.cuda-cpp"],"customLiteral":["entity.name.operator.custom-literal.cuda-cpp"],"stringLiteral":["entity.name.operator.custom-literal.string.cuda-cpp"]}}],"codeActions":[{"languages":["c","cpp","cuda-cpp"],"actions":{"kind":"refactor.inline.macro","title":"%c_cpp.codeActions.refactor.inline.macro.title%","description":"%c_cpp.codeActions.refactor.inline.macro.description%"}},{"languages":["c","cpp","cuda-cpp"],"actions":{"kind":"refactor.extract.function","title":"%c_cpp.codeActions.refactor.extract.function.title%","description":"%c_cpp.codeActions.refactor.extract.function.description%"}}]},"resolutions":{"chokidar":"^3.5.3","gulp-mocha/mocha/nanoid":"^3.1.20","gulp-mocha/mocha/minimatch":"^3.0.5","gulp/**/glob-parent":"^5.1.2"}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/README.md', import.meta.url).href, 'text/markdown');

registerFileUrl('CHANGELOG.md', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/CHANGELOG.md', import.meta.url).href, 'text/markdown');

registerFileUrl('package.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.cs.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.cs.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.de.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.de.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.es.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.es.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.fr.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.fr.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.it.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.it.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ja.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.ja.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ko.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.ko.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pl.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.pl.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pt-br.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.pt-br.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.ru.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.ru.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.tr.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.tr.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-cn.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.zh-cn.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-tw.json', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/package.nls.zh-tw.json', import.meta.url).href, 'application/json');

registerFileUrl('LanguageCCPP_color_128x.png', new URL('../assets/ms-vscode.cpptools-1.19.2.vsix/LanguageCCPP_color_128x.png', import.meta.url).href, 'image/png');

export { whenReady };
