import { registerExtension } from 'vscode/extensions';

const manifest = {"author":"sumneko","capabilities":{"untrustedWorkspaces":{"description":"","restrictedConfigurations":["Lua.runtime.plugin","Lua.misc.parameters"],"supported":"limited"}},"categories":["Linters","Programming Languages","Snippets"],"contributes":{"configuration":{"properties":{"Lua.addonManager.enable":{"default":true,"markdownDescription":"%config.addonManager.enable%","scope":"resource","type":"boolean"},"Lua.codeLens.enable":{"default":false,"markdownDescription":"%config.codeLens.enable%","scope":"resource","type":"boolean"},"Lua.completion.autoRequire":{"default":true,"markdownDescription":"%config.completion.autoRequire%","scope":"resource","type":"boolean"},"Lua.completion.callSnippet":{"default":"Disable","enum":["Disable","Both","Replace"],"markdownDescription":"%config.completion.callSnippet%","markdownEnumDescriptions":["%config.completion.callSnippet.Disable%","%config.completion.callSnippet.Both%","%config.completion.callSnippet.Replace%"],"scope":"resource","type":"string"},"Lua.completion.displayContext":{"default":0,"markdownDescription":"%config.completion.displayContext%","scope":"resource","type":"integer"},"Lua.completion.enable":{"default":true,"markdownDescription":"%config.completion.enable%","scope":"resource","type":"boolean"},"Lua.completion.keywordSnippet":{"default":"Replace","enum":["Disable","Both","Replace"],"markdownDescription":"%config.completion.keywordSnippet%","markdownEnumDescriptions":["%config.completion.keywordSnippet.Disable%","%config.completion.keywordSnippet.Both%","%config.completion.keywordSnippet.Replace%"],"scope":"resource","type":"string"},"Lua.completion.postfix":{"default":"@","markdownDescription":"%config.completion.postfix%","scope":"resource","type":"string"},"Lua.completion.requireSeparator":{"default":".","markdownDescription":"%config.completion.requireSeparator%","scope":"resource","type":"string"},"Lua.completion.showParams":{"default":true,"markdownDescription":"%config.completion.showParams%","scope":"resource","type":"boolean"},"Lua.completion.showWord":{"default":"Fallback","enum":["Enable","Fallback","Disable"],"markdownDescription":"%config.completion.showWord%","markdownEnumDescriptions":["%config.completion.showWord.Enable%","%config.completion.showWord.Fallback%","%config.completion.showWord.Disable%"],"scope":"resource","type":"string"},"Lua.completion.workspaceWord":{"default":true,"markdownDescription":"%config.completion.workspaceWord%","scope":"resource","type":"boolean"},"Lua.diagnostics.disable":{"default":[],"items":{"enum":["action-after-return","ambiguity-1","ambiguous-syntax","args-after-dots","assign-type-mismatch","await-in-sync","block-after-else","break-outside","cast-local-type","cast-type-mismatch","circle-doc-class","close-non-object","code-after-break","codestyle-check","count-down-loop","deprecated","different-requires","discard-returns","doc-field-no-class","duplicate-doc-alias","duplicate-doc-field","duplicate-doc-param","duplicate-index","duplicate-set-field","empty-block","err-assign-as-eq","err-c-long-comment","err-comment-prefix","err-do-as-then","err-eq-as-assign","err-esc","err-nonstandard-symbol","err-then-as-do","exp-in-action","global-element","global-in-nil-env","incomplete-signature-doc","index-in-func-name","inject-field","invisible","jump-local-scope","keyword","local-limit","lowercase-global","lua-doc-miss-sign","luadoc-error-diag-mode","luadoc-miss-alias-extends","luadoc-miss-alias-name","luadoc-miss-arg-name","luadoc-miss-cate-name","luadoc-miss-class-extends-name","luadoc-miss-class-name","luadoc-miss-diag-mode","luadoc-miss-diag-name","luadoc-miss-field-extends","luadoc-miss-field-name","luadoc-miss-fun-after-overload","luadoc-miss-generic-name","luadoc-miss-local-name","luadoc-miss-module-name","luadoc-miss-operator-name","luadoc-miss-param-extends","luadoc-miss-param-name","luadoc-miss-see-name","luadoc-miss-sign-name","luadoc-miss-symbol","luadoc-miss-type-name","luadoc-miss-vararg-type","luadoc-miss-version","malformed-number","miss-end","miss-esc-x","miss-exp","miss-exponent","miss-field","miss-loop-max","miss-loop-min","miss-method","miss-name","miss-sep-in-table","miss-space-between","miss-symbol","missing-fields","missing-global-doc","missing-local-export-doc","missing-parameter","missing-return","missing-return-value","name-style-check","need-check-nil","need-paren","nesting-long-mark","newfield-call","newline-call","no-unknown","no-visible-label","not-yieldable","param-type-mismatch","redefined-label","redefined-local","redundant-parameter","redundant-return","redundant-return-value","redundant-value","return-type-mismatch","set-const","spell-check","trailing-space","unbalanced-assignments","undefined-doc-class","undefined-doc-name","undefined-doc-param","undefined-env-child","undefined-field","undefined-global","unexpect-dots","unexpect-efunc-name","unexpect-lfunc-name","unexpect-symbol","unicode-name","unknown-attribute","unknown-cast-variable","unknown-diag-code","unknown-operator","unknown-symbol","unreachable-code","unsupport-symbol","unused-function","unused-label","unused-local","unused-vararg"],"type":"string"},"markdownDescription":"%config.diagnostics.disable%","scope":"resource","type":"array"},"Lua.diagnostics.disableScheme":{"default":["git"],"items":{"type":"string"},"markdownDescription":"%config.diagnostics.disableScheme%","scope":"resource","type":"array"},"Lua.diagnostics.enable":{"default":true,"markdownDescription":"%config.diagnostics.enable%","scope":"resource","type":"boolean"},"Lua.diagnostics.globals":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.diagnostics.globals%","scope":"resource","type":"array"},"Lua.diagnostics.groupFileStatus":{"additionalProperties":false,"markdownDescription":"%config.diagnostics.groupFileStatus%","properties":{"ambiguity":{"default":"Fallback","description":"%config.diagnostics.ambiguity%","enum":["Any","Opened","None","Fallback"],"type":"string"},"await":{"default":"Fallback","description":"%config.diagnostics.await%","enum":["Any","Opened","None","Fallback"],"type":"string"},"codestyle":{"default":"Fallback","description":"%config.diagnostics.codestyle%","enum":["Any","Opened","None","Fallback"],"type":"string"},"conventions":{"default":"Fallback","description":"%config.diagnostics.conventions%","enum":["Any","Opened","None","Fallback"],"type":"string"},"duplicate":{"default":"Fallback","description":"%config.diagnostics.duplicate%","enum":["Any","Opened","None","Fallback"],"type":"string"},"global":{"default":"Fallback","description":"%config.diagnostics.global%","enum":["Any","Opened","None","Fallback"],"type":"string"},"luadoc":{"default":"Fallback","description":"%config.diagnostics.luadoc%","enum":["Any","Opened","None","Fallback"],"type":"string"},"redefined":{"default":"Fallback","description":"%config.diagnostics.redefined%","enum":["Any","Opened","None","Fallback"],"type":"string"},"strict":{"default":"Fallback","description":"%config.diagnostics.strict%","enum":["Any","Opened","None","Fallback"],"type":"string"},"strong":{"default":"Fallback","description":"%config.diagnostics.strong%","enum":["Any","Opened","None","Fallback"],"type":"string"},"type-check":{"default":"Fallback","description":"%config.diagnostics.type-check%","enum":["Any","Opened","None","Fallback"],"type":"string"},"unbalanced":{"default":"Fallback","description":"%config.diagnostics.unbalanced%","enum":["Any","Opened","None","Fallback"],"type":"string"},"unused":{"default":"Fallback","description":"%config.diagnostics.unused%","enum":["Any","Opened","None","Fallback"],"type":"string"}},"scope":"resource","title":"groupFileStatus","type":"object"},"Lua.diagnostics.groupSeverity":{"additionalProperties":false,"markdownDescription":"%config.diagnostics.groupSeverity%","properties":{"ambiguity":{"default":"Fallback","description":"%config.diagnostics.ambiguity%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"await":{"default":"Fallback","description":"%config.diagnostics.await%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"codestyle":{"default":"Fallback","description":"%config.diagnostics.codestyle%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"conventions":{"default":"Fallback","description":"%config.diagnostics.conventions%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"duplicate":{"default":"Fallback","description":"%config.diagnostics.duplicate%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"global":{"default":"Fallback","description":"%config.diagnostics.global%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"luadoc":{"default":"Fallback","description":"%config.diagnostics.luadoc%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"redefined":{"default":"Fallback","description":"%config.diagnostics.redefined%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"strict":{"default":"Fallback","description":"%config.diagnostics.strict%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"strong":{"default":"Fallback","description":"%config.diagnostics.strong%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"type-check":{"default":"Fallback","description":"%config.diagnostics.type-check%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"unbalanced":{"default":"Fallback","description":"%config.diagnostics.unbalanced%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"},"unused":{"default":"Fallback","description":"%config.diagnostics.unused%","enum":["Error","Warning","Information","Hint","Fallback"],"type":"string"}},"scope":"resource","title":"groupSeverity","type":"object"},"Lua.diagnostics.ignoredFiles":{"default":"Opened","enum":["Enable","Opened","Disable"],"markdownDescription":"%config.diagnostics.ignoredFiles%","markdownEnumDescriptions":["%config.diagnostics.ignoredFiles.Enable%","%config.diagnostics.ignoredFiles.Opened%","%config.diagnostics.ignoredFiles.Disable%"],"scope":"resource","type":"string"},"Lua.diagnostics.libraryFiles":{"default":"Opened","enum":["Enable","Opened","Disable"],"markdownDescription":"%config.diagnostics.libraryFiles%","markdownEnumDescriptions":["%config.diagnostics.libraryFiles.Enable%","%config.diagnostics.libraryFiles.Opened%","%config.diagnostics.libraryFiles.Disable%"],"scope":"resource","type":"string"},"Lua.diagnostics.neededFileStatus":{"additionalProperties":false,"markdownDescription":"%config.diagnostics.neededFileStatus%","properties":{"ambiguity-1":{"default":"Any","description":"%config.diagnostics.ambiguity-1%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"assign-type-mismatch":{"default":"Opened","description":"%config.diagnostics.assign-type-mismatch%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"await-in-sync":{"default":"None","description":"%config.diagnostics.await-in-sync%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"cast-local-type":{"default":"Opened","description":"%config.diagnostics.cast-local-type%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"cast-type-mismatch":{"default":"Opened","description":"%config.diagnostics.cast-type-mismatch%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"circle-doc-class":{"default":"Any","description":"%config.diagnostics.circle-doc-class%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"close-non-object":{"default":"Any","description":"%config.diagnostics.close-non-object%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"code-after-break":{"default":"Opened","description":"%config.diagnostics.code-after-break%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"codestyle-check":{"default":"None","description":"%config.diagnostics.codestyle-check%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"count-down-loop":{"default":"Any","description":"%config.diagnostics.count-down-loop%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"deprecated":{"default":"Any","description":"%config.diagnostics.deprecated%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"different-requires":{"default":"Any","description":"%config.diagnostics.different-requires%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"discard-returns":{"default":"Any","description":"%config.diagnostics.discard-returns%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"doc-field-no-class":{"default":"Any","description":"%config.diagnostics.doc-field-no-class%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"duplicate-doc-alias":{"default":"Any","description":"%config.diagnostics.duplicate-doc-alias%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"duplicate-doc-field":{"default":"Any","description":"%config.diagnostics.duplicate-doc-field%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"duplicate-doc-param":{"default":"Any","description":"%config.diagnostics.duplicate-doc-param%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"duplicate-index":{"default":"Any","description":"%config.diagnostics.duplicate-index%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"duplicate-set-field":{"default":"Opened","description":"%config.diagnostics.duplicate-set-field%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"empty-block":{"default":"Opened","description":"%config.diagnostics.empty-block%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"global-element":{"default":"None","description":"%config.diagnostics.global-element%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"global-in-nil-env":{"default":"Any","description":"%config.diagnostics.global-in-nil-env%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"incomplete-signature-doc":{"default":"None","description":"%config.diagnostics.incomplete-signature-doc%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"inject-field":{"default":"Opened","description":"%config.diagnostics.inject-field%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"invisible":{"default":"Any","description":"%config.diagnostics.invisible%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"lowercase-global":{"default":"Any","description":"%config.diagnostics.lowercase-global%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-fields":{"default":"Any","description":"%config.diagnostics.missing-fields%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-global-doc":{"default":"None","description":"%config.diagnostics.missing-global-doc%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-local-export-doc":{"default":"None","description":"%config.diagnostics.missing-local-export-doc%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-parameter":{"default":"Any","description":"%config.diagnostics.missing-parameter%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-return":{"default":"Any","description":"%config.diagnostics.missing-return%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"missing-return-value":{"default":"Any","description":"%config.diagnostics.missing-return-value%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"name-style-check":{"default":"None","description":"%config.diagnostics.name-style-check%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"need-check-nil":{"default":"Opened","description":"%config.diagnostics.need-check-nil%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"newfield-call":{"default":"Any","description":"%config.diagnostics.newfield-call%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"newline-call":{"default":"Any","description":"%config.diagnostics.newline-call%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"no-unknown":{"default":"None","description":"%config.diagnostics.no-unknown%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"not-yieldable":{"default":"None","description":"%config.diagnostics.not-yieldable%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"param-type-mismatch":{"default":"Opened","description":"%config.diagnostics.param-type-mismatch%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"redefined-local":{"default":"Opened","description":"%config.diagnostics.redefined-local%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"redundant-parameter":{"default":"Any","description":"%config.diagnostics.redundant-parameter%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"redundant-return":{"default":"Opened","description":"%config.diagnostics.redundant-return%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"redundant-return-value":{"default":"Any","description":"%config.diagnostics.redundant-return-value%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"redundant-value":{"default":"Any","description":"%config.diagnostics.redundant-value%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"return-type-mismatch":{"default":"Opened","description":"%config.diagnostics.return-type-mismatch%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"spell-check":{"default":"None","description":"%config.diagnostics.spell-check%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"trailing-space":{"default":"Opened","description":"%config.diagnostics.trailing-space%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unbalanced-assignments":{"default":"Any","description":"%config.diagnostics.unbalanced-assignments%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-doc-class":{"default":"Any","description":"%config.diagnostics.undefined-doc-class%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-doc-name":{"default":"Any","description":"%config.diagnostics.undefined-doc-name%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-doc-param":{"default":"Any","description":"%config.diagnostics.undefined-doc-param%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-env-child":{"default":"Any","description":"%config.diagnostics.undefined-env-child%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-field":{"default":"Opened","description":"%config.diagnostics.undefined-field%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"undefined-global":{"default":"Any","description":"%config.diagnostics.undefined-global%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unknown-cast-variable":{"default":"Any","description":"%config.diagnostics.unknown-cast-variable%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unknown-diag-code":{"default":"Any","description":"%config.diagnostics.unknown-diag-code%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unknown-operator":{"default":"Any","description":"%config.diagnostics.unknown-operator%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unreachable-code":{"default":"Opened","description":"%config.diagnostics.unreachable-code%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unused-function":{"default":"Opened","description":"%config.diagnostics.unused-function%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unused-label":{"default":"Opened","description":"%config.diagnostics.unused-label%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unused-local":{"default":"Opened","description":"%config.diagnostics.unused-local%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"},"unused-vararg":{"default":"Opened","description":"%config.diagnostics.unused-vararg%","enum":["Any","Opened","None","Any!","Opened!","None!"],"type":"string"}},"scope":"resource","title":"neededFileStatus","type":"object"},"Lua.diagnostics.severity":{"additionalProperties":false,"markdownDescription":"%config.diagnostics.severity%","properties":{"ambiguity-1":{"default":"Warning","description":"%config.diagnostics.ambiguity-1%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"assign-type-mismatch":{"default":"Warning","description":"%config.diagnostics.assign-type-mismatch%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"await-in-sync":{"default":"Warning","description":"%config.diagnostics.await-in-sync%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"cast-local-type":{"default":"Warning","description":"%config.diagnostics.cast-local-type%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"cast-type-mismatch":{"default":"Warning","description":"%config.diagnostics.cast-type-mismatch%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"circle-doc-class":{"default":"Warning","description":"%config.diagnostics.circle-doc-class%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"close-non-object":{"default":"Warning","description":"%config.diagnostics.close-non-object%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"code-after-break":{"default":"Hint","description":"%config.diagnostics.code-after-break%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"codestyle-check":{"default":"Warning","description":"%config.diagnostics.codestyle-check%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"count-down-loop":{"default":"Warning","description":"%config.diagnostics.count-down-loop%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"deprecated":{"default":"Warning","description":"%config.diagnostics.deprecated%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"different-requires":{"default":"Warning","description":"%config.diagnostics.different-requires%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"discard-returns":{"default":"Warning","description":"%config.diagnostics.discard-returns%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"doc-field-no-class":{"default":"Warning","description":"%config.diagnostics.doc-field-no-class%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"duplicate-doc-alias":{"default":"Warning","description":"%config.diagnostics.duplicate-doc-alias%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"duplicate-doc-field":{"default":"Warning","description":"%config.diagnostics.duplicate-doc-field%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"duplicate-doc-param":{"default":"Warning","description":"%config.diagnostics.duplicate-doc-param%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"duplicate-index":{"default":"Warning","description":"%config.diagnostics.duplicate-index%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"duplicate-set-field":{"default":"Warning","description":"%config.diagnostics.duplicate-set-field%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"empty-block":{"default":"Hint","description":"%config.diagnostics.empty-block%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"global-element":{"default":"Warning","description":"%config.diagnostics.global-element%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"global-in-nil-env":{"default":"Warning","description":"%config.diagnostics.global-in-nil-env%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"incomplete-signature-doc":{"default":"Warning","description":"%config.diagnostics.incomplete-signature-doc%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"inject-field":{"default":"Warning","description":"%config.diagnostics.inject-field%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"invisible":{"default":"Warning","description":"%config.diagnostics.invisible%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"lowercase-global":{"default":"Information","description":"%config.diagnostics.lowercase-global%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-fields":{"default":"Warning","description":"%config.diagnostics.missing-fields%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-global-doc":{"default":"Warning","description":"%config.diagnostics.missing-global-doc%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-local-export-doc":{"default":"Warning","description":"%config.diagnostics.missing-local-export-doc%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-parameter":{"default":"Warning","description":"%config.diagnostics.missing-parameter%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-return":{"default":"Warning","description":"%config.diagnostics.missing-return%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"missing-return-value":{"default":"Warning","description":"%config.diagnostics.missing-return-value%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"name-style-check":{"default":"Warning","description":"%config.diagnostics.name-style-check%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"need-check-nil":{"default":"Warning","description":"%config.diagnostics.need-check-nil%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"newfield-call":{"default":"Warning","description":"%config.diagnostics.newfield-call%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"newline-call":{"default":"Warning","description":"%config.diagnostics.newline-call%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"no-unknown":{"default":"Warning","description":"%config.diagnostics.no-unknown%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"not-yieldable":{"default":"Warning","description":"%config.diagnostics.not-yieldable%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"param-type-mismatch":{"default":"Warning","description":"%config.diagnostics.param-type-mismatch%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"redefined-local":{"default":"Hint","description":"%config.diagnostics.redefined-local%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"redundant-parameter":{"default":"Warning","description":"%config.diagnostics.redundant-parameter%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"redundant-return":{"default":"Hint","description":"%config.diagnostics.redundant-return%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"redundant-return-value":{"default":"Warning","description":"%config.diagnostics.redundant-return-value%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"redundant-value":{"default":"Warning","description":"%config.diagnostics.redundant-value%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"return-type-mismatch":{"default":"Warning","description":"%config.diagnostics.return-type-mismatch%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"spell-check":{"default":"Information","description":"%config.diagnostics.spell-check%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"trailing-space":{"default":"Hint","description":"%config.diagnostics.trailing-space%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unbalanced-assignments":{"default":"Warning","description":"%config.diagnostics.unbalanced-assignments%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-doc-class":{"default":"Warning","description":"%config.diagnostics.undefined-doc-class%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-doc-name":{"default":"Warning","description":"%config.diagnostics.undefined-doc-name%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-doc-param":{"default":"Warning","description":"%config.diagnostics.undefined-doc-param%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-env-child":{"default":"Information","description":"%config.diagnostics.undefined-env-child%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-field":{"default":"Warning","description":"%config.diagnostics.undefined-field%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"undefined-global":{"default":"Warning","description":"%config.diagnostics.undefined-global%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unknown-cast-variable":{"default":"Warning","description":"%config.diagnostics.unknown-cast-variable%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unknown-diag-code":{"default":"Warning","description":"%config.diagnostics.unknown-diag-code%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unknown-operator":{"default":"Warning","description":"%config.diagnostics.unknown-operator%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unreachable-code":{"default":"Hint","description":"%config.diagnostics.unreachable-code%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unused-function":{"default":"Hint","description":"%config.diagnostics.unused-function%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unused-label":{"default":"Hint","description":"%config.diagnostics.unused-label%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unused-local":{"default":"Hint","description":"%config.diagnostics.unused-local%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"},"unused-vararg":{"default":"Hint","description":"%config.diagnostics.unused-vararg%","enum":["Error","Warning","Information","Hint","Error!","Warning!","Information!","Hint!"],"type":"string"}},"scope":"resource","title":"severity","type":"object"},"Lua.diagnostics.unusedLocalExclude":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.diagnostics.unusedLocalExclude%","scope":"resource","type":"array"},"Lua.diagnostics.workspaceDelay":{"default":3000,"markdownDescription":"%config.diagnostics.workspaceDelay%","scope":"resource","type":"integer"},"Lua.diagnostics.workspaceEvent":{"default":"OnSave","enum":["OnChange","OnSave","None"],"markdownDescription":"%config.diagnostics.workspaceEvent%","markdownEnumDescriptions":["%config.diagnostics.workspaceEvent.OnChange%","%config.diagnostics.workspaceEvent.OnSave%","%config.diagnostics.workspaceEvent.None%"],"scope":"resource","type":"string"},"Lua.diagnostics.workspaceRate":{"default":100,"markdownDescription":"%config.diagnostics.workspaceRate%","scope":"resource","type":"integer"},"Lua.doc.packageName":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.doc.packageName%","scope":"resource","type":"array"},"Lua.doc.privateName":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.doc.privateName%","scope":"resource","type":"array"},"Lua.doc.protectedName":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.doc.protectedName%","scope":"resource","type":"array"},"Lua.format.defaultConfig":{"additionalProperties":false,"default":{},"markdownDescription":"%config.format.defaultConfig%","patternProperties":{".*":{"default":"","type":"string"}},"scope":"resource","title":"defaultConfig","type":"object"},"Lua.format.enable":{"default":true,"markdownDescription":"%config.format.enable%","scope":"resource","type":"boolean"},"Lua.hint.arrayIndex":{"default":"Auto","enum":["Enable","Auto","Disable"],"markdownDescription":"%config.hint.arrayIndex%","markdownEnumDescriptions":["%config.hint.arrayIndex.Enable%","%config.hint.arrayIndex.Auto%","%config.hint.arrayIndex.Disable%"],"scope":"resource","type":"string"},"Lua.hint.await":{"default":true,"markdownDescription":"%config.hint.await%","scope":"resource","type":"boolean"},"Lua.hint.enable":{"default":false,"markdownDescription":"%config.hint.enable%","scope":"resource","type":"boolean"},"Lua.hint.paramName":{"default":"All","enum":["All","Literal","Disable"],"markdownDescription":"%config.hint.paramName%","markdownEnumDescriptions":["%config.hint.paramName.All%","%config.hint.paramName.Literal%","%config.hint.paramName.Disable%"],"scope":"resource","type":"string"},"Lua.hint.paramType":{"default":true,"markdownDescription":"%config.hint.paramType%","scope":"resource","type":"boolean"},"Lua.hint.semicolon":{"default":"SameLine","enum":["All","SameLine","Disable"],"markdownDescription":"%config.hint.semicolon%","markdownEnumDescriptions":["%config.hint.semicolon.All%","%config.hint.semicolon.SameLine%","%config.hint.semicolon.Disable%"],"scope":"resource","type":"string"},"Lua.hint.setType":{"default":false,"markdownDescription":"%config.hint.setType%","scope":"resource","type":"boolean"},"Lua.hover.enable":{"default":true,"markdownDescription":"%config.hover.enable%","scope":"resource","type":"boolean"},"Lua.hover.enumsLimit":{"default":5,"markdownDescription":"%config.hover.enumsLimit%","scope":"resource","type":"integer"},"Lua.hover.expandAlias":{"default":true,"markdownDescription":"%config.hover.expandAlias%","scope":"resource","type":"boolean"},"Lua.hover.previewFields":{"default":50,"markdownDescription":"%config.hover.previewFields%","scope":"resource","type":"integer"},"Lua.hover.viewNumber":{"default":true,"markdownDescription":"%config.hover.viewNumber%","scope":"resource","type":"boolean"},"Lua.hover.viewString":{"default":true,"markdownDescription":"%config.hover.viewString%","scope":"resource","type":"boolean"},"Lua.hover.viewStringMax":{"default":1000,"markdownDescription":"%config.hover.viewStringMax%","scope":"resource","type":"integer"},"Lua.misc.executablePath":{"default":"","markdownDescription":"%config.misc.executablePath%","scope":"resource","type":"string"},"Lua.misc.parameters":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.misc.parameters%","scope":"resource","type":"array"},"Lua.nameStyle.config":{"additionalProperties":false,"default":{},"markdownDescription":"%config.nameStyle.config%","patternProperties":{".*":{"type":["string","array"]}},"scope":"resource","title":"config","type":"object"},"Lua.runtime.builtin":{"additionalProperties":false,"markdownDescription":"%config.runtime.builtin%","properties":{"basic":{"default":"default","description":"%config.runtime.builtin.basic%","enum":["default","enable","disable"],"type":"string"},"bit":{"default":"default","description":"%config.runtime.builtin.bit%","enum":["default","enable","disable"],"type":"string"},"bit32":{"default":"default","description":"%config.runtime.builtin.bit32%","enum":["default","enable","disable"],"type":"string"},"builtin":{"default":"default","description":"%config.runtime.builtin.builtin%","enum":["default","enable","disable"],"type":"string"},"coroutine":{"default":"default","description":"%config.runtime.builtin.coroutine%","enum":["default","enable","disable"],"type":"string"},"debug":{"default":"default","description":"%config.runtime.builtin.debug%","enum":["default","enable","disable"],"type":"string"},"ffi":{"default":"default","description":"%config.runtime.builtin.ffi%","enum":["default","enable","disable"],"type":"string"},"io":{"default":"default","description":"%config.runtime.builtin.io%","enum":["default","enable","disable"],"type":"string"},"jit":{"default":"default","description":"%config.runtime.builtin.jit%","enum":["default","enable","disable"],"type":"string"},"jit.profile":{"default":"default","description":"%config.runtime.builtin.jit.profile%","enum":["default","enable","disable"],"type":"string"},"jit.util":{"default":"default","description":"%config.runtime.builtin.jit.util%","enum":["default","enable","disable"],"type":"string"},"math":{"default":"default","description":"%config.runtime.builtin.math%","enum":["default","enable","disable"],"type":"string"},"os":{"default":"default","description":"%config.runtime.builtin.os%","enum":["default","enable","disable"],"type":"string"},"package":{"default":"default","description":"%config.runtime.builtin.package%","enum":["default","enable","disable"],"type":"string"},"string":{"default":"default","description":"%config.runtime.builtin.string%","enum":["default","enable","disable"],"type":"string"},"string.buffer":{"default":"default","description":"%config.runtime.builtin.string.buffer%","enum":["default","enable","disable"],"type":"string"},"table":{"default":"default","description":"%config.runtime.builtin.table%","enum":["default","enable","disable"],"type":"string"},"table.clear":{"default":"default","description":"%config.runtime.builtin.table.clear%","enum":["default","enable","disable"],"type":"string"},"table.new":{"default":"default","description":"%config.runtime.builtin.table.new%","enum":["default","enable","disable"],"type":"string"},"utf8":{"default":"default","description":"%config.runtime.builtin.utf8%","enum":["default","enable","disable"],"type":"string"}},"scope":"resource","title":"builtin","type":"object"},"Lua.runtime.fileEncoding":{"default":"utf8","enum":["utf8","ansi","utf16le","utf16be"],"markdownDescription":"%config.runtime.fileEncoding%","markdownEnumDescriptions":["%config.runtime.fileEncoding.utf8%","%config.runtime.fileEncoding.ansi%","%config.runtime.fileEncoding.utf16le%","%config.runtime.fileEncoding.utf16be%"],"scope":"resource","type":"string"},"Lua.runtime.meta":{"default":"${version} ${language} ${encoding}","markdownDescription":"%config.runtime.meta%","scope":"resource","type":"string"},"Lua.runtime.nonstandardSymbol":{"default":[],"items":{"enum":["//","/**/","`","+=","-=","*=","/=","%=","^=","//=","|=","&=","<<=",">>=","||","&&","!","!=","continue"],"type":"string"},"markdownDescription":"%config.runtime.nonstandardSymbol%","scope":"resource","type":"array"},"Lua.runtime.path":{"default":["?.lua","?/init.lua"],"items":{"type":"string"},"markdownDescription":"%config.runtime.path%","scope":"resource","type":"array"},"Lua.runtime.pathStrict":{"default":false,"markdownDescription":"%config.runtime.pathStrict%","scope":"resource","type":"boolean"},"Lua.runtime.plugin":{"default":"","markdownDescription":"%config.runtime.plugin%","scope":"resource","type":"string"},"Lua.runtime.pluginArgs":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.runtime.pluginArgs%","scope":"resource","type":"array"},"Lua.runtime.special":{"additionalProperties":false,"default":{},"markdownDescription":"%config.runtime.special%","patternProperties":{".*":{"default":"require","enum":["_G","rawset","rawget","setmetatable","require","dofile","loadfile","pcall","xpcall","assert","error","type","os.exit"],"type":"string"}},"scope":"resource","title":"special","type":"object"},"Lua.runtime.unicodeName":{"default":false,"markdownDescription":"%config.runtime.unicodeName%","scope":"resource","type":"boolean"},"Lua.runtime.version":{"default":"Lua 5.4","enum":["Lua 5.1","Lua 5.2","Lua 5.3","Lua 5.4","LuaJIT"],"markdownDescription":"%config.runtime.version%","markdownEnumDescriptions":["%config.runtime.version.Lua 5.1%","%config.runtime.version.Lua 5.2%","%config.runtime.version.Lua 5.3%","%config.runtime.version.Lua 5.4%","%config.runtime.version.LuaJIT%"],"scope":"resource","type":"string"},"Lua.semantic.annotation":{"default":true,"markdownDescription":"%config.semantic.annotation%","scope":"resource","type":"boolean"},"Lua.semantic.enable":{"default":true,"markdownDescription":"%config.semantic.enable%","scope":"resource","type":"boolean"},"Lua.semantic.keyword":{"default":false,"markdownDescription":"%config.semantic.keyword%","scope":"resource","type":"boolean"},"Lua.semantic.variable":{"default":true,"markdownDescription":"%config.semantic.variable%","scope":"resource","type":"boolean"},"Lua.signatureHelp.enable":{"default":true,"markdownDescription":"%config.signatureHelp.enable%","scope":"resource","type":"boolean"},"Lua.spell.dict":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.spell.dict%","scope":"resource","type":"array"},"Lua.type.castNumberToInteger":{"default":true,"markdownDescription":"%config.type.castNumberToInteger%","scope":"resource","type":"boolean"},"Lua.type.weakNilCheck":{"default":false,"markdownDescription":"%config.type.weakNilCheck%","scope":"resource","type":"boolean"},"Lua.type.weakUnionCheck":{"default":false,"markdownDescription":"%config.type.weakUnionCheck%","scope":"resource","type":"boolean"},"Lua.typeFormat.config":{"additionalProperties":false,"markdownDescription":"%config.typeFormat.config%","properties":{"auto_complete_end":{"default":"true","description":"%config.typeFormat.config.auto_complete_end%","type":"string"},"auto_complete_table_sep":{"default":"true","description":"%config.typeFormat.config.auto_complete_table_sep%","type":"string"},"format_line":{"default":"true","description":"%config.typeFormat.config.format_line%","type":"string"}},"scope":"resource","title":"config","type":"object"},"Lua.window.progressBar":{"default":true,"markdownDescription":"%config.window.progressBar%","scope":"resource","type":"boolean"},"Lua.window.statusBar":{"default":true,"markdownDescription":"%config.window.statusBar%","scope":"resource","type":"boolean"},"Lua.workspace.checkThirdParty":{"markdownDescription":"%config.workspace.checkThirdParty%","scope":"resource","type":["string","boolean"]},"Lua.workspace.ignoreDir":{"default":[".vscode"],"items":{"type":"string"},"markdownDescription":"%config.workspace.ignoreDir%","scope":"resource","type":"array"},"Lua.workspace.ignoreSubmodules":{"default":true,"markdownDescription":"%config.workspace.ignoreSubmodules%","scope":"resource","type":"boolean"},"Lua.workspace.library":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.workspace.library%","scope":"resource","type":"array"},"Lua.workspace.maxPreload":{"default":5000,"markdownDescription":"%config.workspace.maxPreload%","scope":"resource","type":"integer"},"Lua.workspace.preloadFileSize":{"default":500,"markdownDescription":"%config.workspace.preloadFileSize%","scope":"resource","type":"integer"},"Lua.workspace.useGitIgnore":{"default":true,"markdownDescription":"%config.workspace.useGitIgnore%","scope":"resource","type":"boolean"},"Lua.workspace.userThirdParty":{"default":[],"items":{"type":"string"},"markdownDescription":"%config.workspace.userThirdParty%","scope":"resource","type":"array"}},"title":"Lua","type":"object"},"configurationDefaults":{"[lua]":{"editor.quickSuggestions":{"comments":"inline","other":"on","strings":"on"},"editor.semanticHighlighting.enabled":true}},"jsonValidation":[{"fileMatch":[".luarc.json",".luarc.jsonc"],"url":"./setting/schema.json"}],"languages":[{"filenames":[".luarc.json","config.json"],"id":"jsonc"}],"semanticTokenScopes":[{"language":"lua","scopes":{"class":["support.class.lua"],"class.declaration":["support.class.lua"],"comment.documentation":["storage.type.annotation.lua"],"event.static":["support.class.lua"],"function":["support.function.any-method.lua"],"function.declaration":["entity.name.function.lua"],"function.defaultLibrary":["support.function.lua"],"function.static":["entity.name.function.lua"],"keyword":["keyword.control.lua"],"keyword.async":["entity.name.tag.lua"],"keyword.declaration":["keyword.local.lua"],"keyword.documentation":["storage.type.annotation.lua"],"keyword.readonly":["constant.language.lua"],"macro":["variable.lua"],"method":["entity.name.function.lua"],"method.declaration":["entity.name.function.lua"],"number":["constant.numeric.float.lua"],"number.static":["constant.numeric.integer.lua"],"operator":["keyword.operator.lua"],"parameter.declaration":["variable.parameter.lua"],"property":["entity.other.attribute.lua"],"property.declaration":["entity.other.property.lua"],"string":["string.lua"],"string.deprecated":["invalid.illegal.character.escape.lua"],"string.modification":["constant.character.escape.lua"],"struct":["string.tag.lua"],"struct.declaration":["string.tag.lua"],"type":["support.type.lua"],"type.modification":["storage.type.generic.lua"],"type.readonly":["storage.type.self.lua"],"typeParameter":["string.tag.lua"],"variable":["variable.other.lua"],"variable.abstract":["variable.other.constant.lua"],"variable.declaration":["variable.other.lua"],"variable.defaultLibrary":["support.constant.lua"],"variable.definition":["variable.language.self.lua"],"variable.global":["variable.global.lua"],"variable.readonly":["variable.other.constant.lua"]}}]},"description":"Lua Language Server coded by Lua","displayName":"Lua","engines":{"vscode":"^1.67.0"},"icon":"images/logo.png","keywords":["Lua","IntelliSense","EmmyLua"],"license":"MIT","name":"lua","publisher":"sumneko","repository":{"type":"git","url":"https://github.com/LuaLS/lua-language-server"},"sponsor":{"url":"https://github.com/LuaLS/lua-language-server/issues/484"},"version":"3.7.4"};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"changelog.md"});


registerFileUrl('README.md', new URL('../assets/sumneko.lua-3.7.4.vsix/README.md', import.meta.url).href, 'text/markdown');

registerFileUrl('changelog.md', new URL('../assets/sumneko.lua-3.7.4.vsix/changelog.md', import.meta.url).href, 'text/markdown');

registerFileUrl('setting/schema.json', new URL('../assets/sumneko.lua-3.7.4.vsix/schema.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/sumneko.lua-3.7.4.vsix/package.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.json', new URL('../assets/sumneko.lua-3.7.4.vsix/package.nls.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.pt-br.json', new URL('../assets/sumneko.lua-3.7.4.vsix/package.nls.pt-br.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-cn.json', new URL('../assets/sumneko.lua-3.7.4.vsix/package.nls.zh-cn.json', import.meta.url).href, 'application/json');

registerFileUrl('package.nls.zh-tw.json', new URL('../assets/sumneko.lua-3.7.4.vsix/package.nls.zh-tw.json', import.meta.url).href, 'application/json');

registerFileUrl('images/logo.png', new URL('../assets/sumneko.lua-3.7.4.vsix/logo.png', import.meta.url).href, 'image/png');

export { whenReady };
